#include <qvariant.h>
#include <qtabwidget.h>
#include <qwidget.h>
#include <qgroupbox.h>
#include <qbuttongroup.h>
#include <qlabel.h>
#include <kcolorbutton.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qradiobutton.h>
#include <qslider.h>
#include <qspinbox.h>
#include <qsettings.h>
#include <qframe.h>
#include <qlayout.h>
#include <qtooltip.h>
#include <qwhatsthis.h>

#include <klocale.h>
#include <kglobal.h>
#include <kipc.h>

#include "kcmbaghira.h"
//#include "previewdata.h"

void kcmbaghira::slotInactiveButtonChanged(int id)
{
	(id == 3) ? buttonGroup8->setEnabled(true) : buttonGroup8->setEnabled(false);
	emit changed(true);
}

void kcmbaghira::slotMenuTranslucencyChanged(int id)
{
	(id >= 2) ? groupBox1->setEnabled(true) : groupBox1->setEnabled(false);
	emit changed(true);
}

void kcmbaghira::slotMenuEffectSpeedChanged(int id)
{
	menuEffectSpeedIndicator->setNum(id);
	emit changed(true);
}

void kcmbaghira::slotItemChanged()
{
	emit changed(true);
}

kcmbaghira::kcmbaghira( QWidget *parent, const char *name ) : KCModule( parent, name ) {
	setMinimumSize(620,580);
	QVBoxLayout * layout = new QVBoxLayout( this );
	layout->setGeometry( QRect( 0, 0, 620, 580 ) );
	maintab = new QTabWidget( this, "maintab" );
	maintab->setMinimumSize( 620, 580 );
	maintab->setGeometry( QRect( 10, 30, 600, 550 ) );
	layout->addWidget( maintab );
	tab = new QWidget( maintab, "tab" );
	tab->setMinimumSize( 600, 550 );
	tab->setGeometry( QRect( 10, 30, 600, 550 ) );
	styletab = new QTabWidget( tab, "styletab" );
	styletab->setGeometry( QRect( 10, 30, 570, 480 ) );
	styletab->setMinimumSize( 570, 480 );
//	styletab->setMargin( 0 );

	tab_2 = new QWidget( styletab, "tab_2" );

	groupBox2 = new QGroupBox( tab_2, "groupBox2" );
	groupBox2->setGeometry( QRect( 10, 140, 240, 170 ) );

	buttonGroup6_2 = new QButtonGroup( groupBox2, "buttonGroup6_2" );
	buttonGroup6_2->setEnabled( FALSE );
	buttonGroup6_2->setGeometry( QRect( 20, 60, 190, 70 ) );
	buttonGroup6_2->setFrameShape( QButtonGroup::NoFrame );

	textLabel3_2 = new QLabel( buttonGroup6_2, "textLabel3_2" );
	textLabel3_2->setGeometry( QRect( 10, 40, 39, 20 ) );

	textLabel2_2 = new QLabel( buttonGroup6_2, "textLabel2_2" );
	textLabel2_2->setGeometry( QRect( 10, 10, 49, 20 ) );

	customMenuColor = new KColorButton( buttonGroup6_2, "customMenuColor" );
	customMenuColor->setGeometry( QRect( 120, 10, 54, 23 ) );

	customMenuTextColor = new KColorButton( buttonGroup6_2, "customMenuTextColor" );
	customMenuTextColor->setGeometry( QRect( 120, 40, 54, 23 ) );

	useCustomMenuStyle = new QCheckBox( groupBox2, "useCustomMenuStyle" );
	useCustomMenuStyle->setGeometry( QRect( 10, 40, 210, 24 ) );

	groupBox6_2 = new QGroupBox( tab_2, "groupBox6_2" );
	groupBox6_2->setGeometry( QRect( 10, 320, 240, 121 ) );

	buttonGroup8 = new QButtonGroup( groupBox6_2, "buttonGroup8" );
	buttonGroup8->setEnabled( FALSE );
	buttonGroup8->setGeometry( QRect( 20, 60, 200, 50 ) );
	buttonGroup8->setFrameShape( QButtonGroup::NoFrame );

	textLabel2_4 = new QLabel( buttonGroup8, "textLabel2_4" );
	textLabel2_4->setGeometry( QRect( 0, 20, 64, 20 ) );

	customInactiveButtonColor = new KColorButton( buttonGroup8, "customInactiveButtonColor" );
	customInactiveButtonColor->setGeometry( QRect( 140, 20, 54, 23 ) );

	inactiveButtonColor = new QComboBox( FALSE, groupBox6_2, "inactiveButtonColor" );
	inactiveButtonColor->setGeometry( QRect( 10, 40, 210, 26 ) );

	groupBox4 = new QGroupBox( tab_2, "groupBox4" );
	groupBox4->setGeometry( QRect( 260, 10, 290, 350 ) );

	buttonGroup7 = new QButtonGroup( groupBox4, "buttonGroup7" );
	buttonGroup7->setEnabled( FALSE );
	buttonGroup7->setGeometry( QRect( 20, 70, 250, 260 ) );
	buttonGroup7->setFrameShape( QButtonGroup::NoFrame );

	checkBox9 = new QCheckBox( buttonGroup7, "checkBox9" );
	checkBox9->setEnabled( FALSE );
	checkBox9->setGeometry( QRect( 150, 40, 20, 24 ) );

	checkBox8 = new QCheckBox( buttonGroup7, "checkBox8" );
	checkBox8->setEnabled( FALSE );
	checkBox8->setGeometry( QRect( 150, 10, 16, 24 ) );
	checkBox8->setChecked( TRUE );

	radioButton2 = new QRadioButton( buttonGroup7, "radioButton2" );
	radioButton2->setEnabled( FALSE );
	radioButton2->setGeometry( QRect( 20, 40, 16, 24 ) );

	radioButton1 = new QRadioButton( buttonGroup7, "radioButton1" );
	radioButton1->setEnabled( FALSE );
	radioButton1->setGeometry( QRect( 20, 10, 16, 24 ) );
	radioButton1->setChecked( TRUE );

	textLabel13 = new QLabel( buttonGroup7, "textLabel13" );
	textLabel13->setGeometry( QRect( 20, 80, 51, 20 ) );

	textLabel14 = new QLabel( buttonGroup7, "textLabel14" );
	textLabel14->setGeometry( QRect( 20, 110, 133, 20 ) );

	textLabel15 = new QLabel( buttonGroup7, "textLabel15" );
	textLabel15->setGeometry( QRect( 20, 140, 130, 20 ) );

	textLabel16 = new QLabel( buttonGroup7, "textLabel16" );
	textLabel16->setGeometry( QRect( 20, 170, 113, 20 ) );

	textLabel18 = new QLabel( buttonGroup7, "textLabel18" );
	textLabel18->setGeometry( QRect( 20, 200, 98, 20 ) );

	textLabel17 = new QLabel( buttonGroup7, "textLabel17" );
	textLabel17->setGeometry( QRect( 20, 230, 115, 20 ) );

	customRadioOnColor = new KColorButton( buttonGroup7, "customRadioOnColor" );
	customRadioOnColor->setGeometry( QRect( 50, 10, 54, 23 ) );

	customRadioOffColor = new KColorButton( buttonGroup7, "customRadioOffColor" );
	customRadioOffColor->setGeometry( QRect( 50, 40, 54, 23 ) );

	customCheckOnColor = new KColorButton( buttonGroup7, "customCheckOnColor" );
	customCheckOnColor->setGeometry( QRect( 180, 10, 54, 23 ) );

	customCheckOffColor = new KColorButton( buttonGroup7, "customCheckOffColor" );
	customCheckOffColor->setGeometry( QRect( 180, 40, 54, 23 ) );

	customSliderColor = new KColorButton( buttonGroup7, "customSliderColor" );
	customSliderColor->setGeometry( QRect( 180, 80, 54, 23 ) );

	customHoveredSliderColor = new KColorButton( buttonGroup7, "customHoveredSliderColor" );
	customHoveredSliderColor->setGeometry( QRect( 180, 110, 54, 23 ) );

	customPressedSliderColor = new KColorButton( buttonGroup7, "customPressedSliderColor" );
	customPressedSliderColor->setGeometry( QRect( 180, 140, 54, 23 ) );

	customSliderGrooveColor = new KColorButton( buttonGroup7, "customSliderGrooveColor" );
	customSliderGrooveColor->setGeometry( QRect( 180, 170, 54, 23 ) );

	customActiveTabColor = new KColorButton( buttonGroup7, "customActiveTabColor" );
	customActiveTabColor->setGeometry( QRect( 180, 200, 54, 23 ) );

	customInactiveTabColor = new KColorButton( buttonGroup7, "customInactiveTabColor" );
	customInactiveTabColor->setGeometry( QRect( 180, 230, 54, 23 ) );

	useCustomWidgetColor = new QCheckBox( groupBox4, "useCustomWidgetColor" );
	useCustomWidgetColor->setGeometry( QRect( 10, 40, 250, 24 ) );

	icyButtons = new QCheckBox( tab_2, "icyButtons" );
	icyButtons->setGeometry( QRect( 270, 380, 200, 24 ) );

	groupBox3 = new QGroupBox( tab_2, "groupBox3" );
	groupBox3->setGeometry( QRect( 10, 10, 240, 120 ) );

	useCustomPanelColor = new QCheckBox( groupBox3, "useCustomPanelColor" );
	useCustomPanelColor->setGeometry( QRect( 10, 40, 220, 24 ) );

	customPanelColor = new KColorButton( groupBox3, "customPanelColor" );
	customPanelColor->setEnabled( FALSE );
	customPanelColor->setGeometry( QRect( 30, 70, 54, 23 ) );
	styletab->insertTab( tab_2, QString( "" ) );

	tab_3 = new QWidget( styletab, "tab_3" );

	groupBox1 = new QGroupBox( tab_3, "groupBox1" );
	groupBox1->setEnabled( FALSE );
	groupBox1->setGeometry( QRect( 30, 100, 390, 90 ) );

	textLabel8 = new QLabel( groupBox1, "textLabel8" );
	textLabel8->setGeometry( QRect( 20, 40, 88, 20 ) );

	textLabel9 = new QLabel( groupBox1, "textLabel9" );
	textLabel9->setGeometry( QRect( 110, 60, 220, 20 ) );

	textLabel10 = new QLabel( groupBox1, "textLabel10" );
	textLabel10->setGeometry( QRect( 320, 60, 45, 20 ) );

	customMenuOpacity = new QSlider( groupBox1, "customMenuOpacity" );
	customMenuOpacity->setGeometry( QRect( 110, 40, 250, 24) );
	customMenuOpacity->setMaxValue( 10 );
	customMenuOpacity->setValue( 9 );
	customMenuOpacity->setOrientation( QSlider::Horizontal );

	saturationLabel = new QLabel( tab_2, "saturationLabel" );
	saturationLabel->setGeometry( QRect( 320, 426, 80, 20 ) );

	saturation = new QSlider( tab_2, "saturation" );
	saturation->setGeometry( QRect( 272, 406, 250, 24 ) );
	saturation->setMaxValue( 9 );
	saturation->setValue( 2 );
	saturation->setOrientation( QSlider::Horizontal );

	stippleMenu = new QCheckBox( tab_3, "stippleMenu" );
	stippleMenu->setGeometry( QRect( 30, 220, 380, 24 ) );
	stippleMenu->setChecked( TRUE );

	menuColorButton = new QCheckBox( tab_3, "menuColorButton" );
	menuColorButton->setGeometry( QRect( 30, 280, 380, 24 ) );

	shadowedText = new QCheckBox( tab_3, "shadowedText" );
	shadowedText->setGeometry( QRect( 30, 250, 150, 24 ) );
	
	textLabel7 = new QLabel( tab_3, "textLabel7" );
	textLabel7->setGeometry( QRect( 30, 40, 111, 20 ) );

	menuTranslucency = new QComboBox( FALSE, tab_3, "menuTranslucency" );
	menuTranslucency->setGeometry( QRect( 30, 60, 130, 26 ) );
	
	menuEffectLabel = new QLabel( tab_3, "menuEffectLabel" );
	menuEffectLabel->setGeometry( QRect( 180, 40, 111, 20 ) );
	
	menuEffect = new QComboBox( FALSE, tab_3, "menuEffect" );
	menuEffect->setGeometry( QRect( 180, 60, 130, 26 ) );
	
	menuEffectSpeedLabel = new QLabel( tab_3, "menuEffectSpeedLabel" );
	menuEffectSpeedLabel->setGeometry( QRect( 330, 40, 111, 20 ) );

	menuEffectSpeed = new QSlider( tab_3, "menuEffectSpeed" );
	menuEffectSpeed->setGeometry( QRect( 330, 60, 130, 26 ) );
	menuEffectSpeed->setMaxValue( 100 );
	menuEffectSpeed->setValue( 20 );
	menuEffectSpeed->setOrientation( QSlider::Horizontal );
	menuEffectSpeed->setTickInterval( 1 );
	
	menuEffectSpeedIndicator = new QLabel( tab_3, "menuEffectSpeedIndicator" );
	menuEffectSpeedIndicator->setGeometry( QRect( 470, 60, 50, 26 ) );
		
	menuDropShadows = new QCheckBox( tab_3, "menuDropShadows" );
	menuDropShadows->setGeometry( QRect( 30, 310, 420, 48 ) );

	shadowOffset = new QSpinBox(tab_3,"shadowOffset");
	shadowOffset->setGeometry( QRect( 30, 358, 40, 24) );
	shadowOffset->setMinValue(1);
	shadowOffset->setMaxValue(16);

	shadowOffLabel = new QLabel( tab_3, "shadowOffLabel" );
	shadowOffLabel->setGeometry( QRect( 80, 358, 120, 20 ) );

	dsdLabel = new QLabel( tab_3, "dsdLabel" );
	dsdLabel->setGeometry( QRect( 30, 384, 120, 20 ) );

	dropShadowDarkness = new QSlider( tab_3, "dropShadowDarkness" );
	dropShadowDarkness->setGeometry( QRect( 30, 404, 270, 24 ) );
	dropShadowDarkness->setMaxValue( 3 );
	dropShadowDarkness->setValue( 2 );
	dropShadowDarkness->setOrientation( QSlider::Horizontal );
	dropShadowDarkness->setTickInterval( 1 );


	styletab->insertTab( tab_3, QString( "" ) );

	tab_4 = new QWidget( styletab, "tab_4" );

	line1 = new QFrame( tab_4, "line1" );
	line1->setGeometry( QRect( 20, 110, 530, 16 ) );
	line1->setFrameShape( QFrame::HLine );
	line1->setFrameShadow( QFrame::Sunken );
	line1->setLineWidth( 2 );
	line1->setFrameShape( QFrame::HLine );

	line1_2 = new QFrame( tab_4, "line1_2" );
	line1_2->setGeometry( QRect( 18, 209, 530, 16 ) );
	line1_2->setFrameShape( QFrame::HLine );
	line1_2->setFrameShadow( QFrame::Sunken );
	line1_2->setLineWidth( 2 );
	line1_2->setFrameShape( QFrame::HLine );

	stippleBackground = new QCheckBox( tab_4, "stippleBackground" );
	stippleBackground->setGeometry( QRect( 20, 30, 210, 24 ) );
	stippleBackground->setChecked( TRUE );

	stipplePanel = new QCheckBox( tab_4, "stipplePanel" );
	stipplePanel->setGeometry( QRect( 20, 60, 160, 24 ) );
	stipplePanel->setChecked( TRUE );

	textLabel6 = new QLabel( tab_4, "textLabel6" );
	textLabel6->setGeometry( QRect( 270, 30, 75, 20 ) );

	textLabel2 = new QLabel( tab_4, "textLabel2" );
	textLabel2->setGeometry( QRect( 270, 70, 40, 20 ) );

	textLabel3 = new QLabel( tab_4, "textLabel3" );
	textLabel3->setGeometry( QRect( 500, 70, 43, 20 ) );

	textLabel5 = new QLabel( tab_4, "textLabel5" );
	textLabel5->setGeometry( QRect( 500, 170, 42, 20 ) );

	textLabel4 = new QLabel( tab_4, "textLabel4" );
	textLabel4->setGeometry( QRect( 270, 170, 44, 20 ) );

	drawToolbarButtonFrames = new QCheckBox( tab_4, "drawToolbarButtonFrames" );
	drawToolbarButtonFrames->setGeometry( QRect( 20, 410, 260, 24 ) );
	drawToolbarButtonFrames->setChecked( TRUE );

	squeeze = new QCheckBox( tab_4, "squeeze" );
	squeeze->setGeometry( QRect( 20, 380, 300, 24 ) );
	squeeze->setChecked( TRUE );

	stippleContrast = new QSlider( tab_4, "stippleContrast" );
	stippleContrast->setGeometry( QRect( 270, 50, 270, 24 ) );
	stippleContrast->setMaxValue( 10 );
	stippleContrast->setValue( 3 );
	stippleContrast->setOrientation( QSlider::Horizontal );
	stippleContrast->setTickInterval( 1 );

	shadowDarkness = new QSlider( tab_4, "shadowDarkness" );
	shadowDarkness->setGeometry( QRect( 270, 150, 270, 24 ) );
	shadowDarkness->setMaxValue( 10 );
	shadowDarkness->setValue( 3 );
	shadowDarkness->setOrientation( QSlider::Horizontal );
	shadowDarkness->setTickInterval( 1 );

	groupBox7 = new QGroupBox( tab_4, "groupBox7" );
	groupBox7->setGeometry( QRect( 10, 230, 440, 131 ) );

	textLabel4_3 = new QLabel( groupBox7, "textLabel4_3" );
	textLabel4_3->setGeometry( QRect( 10, 70, 163, 20 ) );

	useCustomExpanderColor = new QCheckBox( groupBox7, "useCustomExpanderColor" );
	useCustomExpanderColor->setGeometry( QRect( 10, 100, 290, 24 ) );

	expanderColor = new KColorButton( groupBox7, "expanderColor" );
	expanderColor->setEnabled( FALSE );
	expanderColor->setGeometry( QRect( 370, 100, 54, 23 ) );

	buttonGroup9 = new QButtonGroup( groupBox7, "buttonGroup9" );
	buttonGroup9->setEnabled( TRUE );
	buttonGroup9->setGeometry( QRect( 201, 30, 230, 31 ) );
	buttonGroup9->setFrameShape( QButtonGroup::NoFrame );

	dotlineStyle = new QComboBox( FALSE, buttonGroup9, "dotlineStyle" );
	dotlineStyle->setGeometry( QRect( 10, 0, 130, 26 ) );

	dotlineColor = new KColorButton( buttonGroup9, "dotlineColor" );
	dotlineColor->setEnabled( TRUE );
	dotlineColor->setGeometry( QRect( 170, 0, 54, 23 ) );

	drawDotlines = new QCheckBox( groupBox7, "drawDotlines" );
	drawDotlines->setGeometry( QRect( 10, 30, 150, 24 ) );
	drawDotlines->setChecked( TRUE );

	expanderStyle = new QComboBox( FALSE, groupBox7, "expanderStyle" );
	expanderStyle->setGeometry( QRect( 210, 70, 130, 26 ) );

	shadowSlider = new QCheckBox( tab_4, "shadowSlider" );
	shadowSlider->setGeometry( QRect( 340, 380, 150, 24 ) );
	shadowSlider->setChecked( TRUE );

	smoothListViewHeaders = new QCheckBox( tab_4, "smoothLVH" );
	smoothListViewHeaders->setGeometry( QRect( 340, 410, 220, 24 ) );

	useGroupShadows = new QCheckBox( tab_4, "useGroupShadows" );
	useGroupShadows->setGeometry( QRect( 20, 150, 200, 40 ) );
	useGroupShadows->setChecked( TRUE );
	styletab->insertTab( tab_4, QString( "" ) );

	tab_5 = new QWidget( styletab, "tab_5" );

	textLabel4_2 = new QLabel( tab_5, "textLabel4_2" );
	textLabel4_2->setGeometry( QRect( 70, 30, 430, 27 ) );

	textLabel3_3 = new QLabel( tab_5, "textLabel3_3" );
	textLabel3_3->setGeometry( QRect( 10, 80, 550, 180 ) );

	line7 = new QFrame( tab_5, "line7" );
	line7->setGeometry( QRect( 40, 260, 480, 20 ) );
	line7->setFrameShape( QFrame::HLine );
	line7->setFrameShadow( QFrame::Sunken );
	line7->setLineWidth( 2 );
	line7->setFrameShape( QFrame::HLine );

	alignStipples = new QCheckBox( tab_5, "alignStipples" );
	alignStipples->setGeometry( QRect( 30, 300, 270, 24 ) );
	centerTabs = new QCheckBox( tab_5, "centerTabs" );
	centerTabs->setGeometry( QRect( 30, 330, 270, 24 ) );
	engageFB = new QCheckBox( tab_5, "engageFB" );
	engageFB->setGeometry( QRect( 30, 360, 270, 24 ) );

	forceRectButtons = new QCheckBox( tab_5, "forceRectButtons" );
	forceRectButtons->setGeometry( QRect( 30, 390, 270, 24 ) );

	progressBar = new QComboBox(FALSE, tab_5, "progressBar" );
	progressBar->setGeometry( QRect( 30, 420, 300, 24 ) );

	removeKickerBevel = new QCheckBox( tab_5, "removeKickerBevel" );
	removeKickerBevel->setGeometry( QRect( 330, 300, 300, 24 ) );

	smoothToolbuttons = new QCheckBox( tab_5, "smoothToolbuttons" );
	smoothToolbuttons->setGeometry( QRect( 330, 330, 300, 24 ) );

	smootherLVH = new QCheckBox( tab_5, "smootherLVH" );
	smootherLVH->setGeometry( QRect( 330, 360, 300, 24 ) );
	
	drawProgressLabel = new QCheckBox( tab_5, "smootherLVH" );
	drawProgressLabel->setGeometry( QRect( 330, 390, 300, 24 ) );
	
	styletab->insertTab( tab_5, QString( "" ) );
	maintab->insertTab( tab, QString( "" ) );

	tab_6 = new QWidget( maintab, "tab_6" );

	textLabel12 = new QLabel( tab_6, "textLabel12" );
	textLabel12->setGeometry( QRect( 60, 70, 461, 380 ) );
	textLabel12->setAlignment( int( QLabel::WordBreak | QLabel::AlignVCenter ) );
	maintab->insertTab( tab_6, QString( "" ) );
	/*kcmbaghira::*/languageChange();
	resize( QSize( 620, 585 ) );
	clearWState( WState_Polished );

	// signals and slots connections
	connect(useCustomMenuStyle, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(menuColorButton, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(stippleMenu, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(shadowedText, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(useCustomWidgetColor, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(useCustomPanelColor, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(inactiveButtonColor, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(stippleBackground, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(stipplePanel, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(drawToolbarButtonFrames, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(squeeze, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(useCustomExpanderColor, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(drawDotlines, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(shadowSlider, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(smoothListViewHeaders, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(useGroupShadows, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(alignStipples, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(centerTabs, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(engageFB, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(icyButtons, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(forceRectButtons, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(progressBar, SIGNAL( activated(int) ), this, SLOT(slotItemChanged()));
	connect(removeKickerBevel, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(smoothToolbuttons, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(smootherLVH, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(drawProgressLabel, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));
	connect(menuDropShadows, SIGNAL( toggled( bool ) ), this, SLOT(slotItemChanged()));

	connect(dotlineStyle, SIGNAL( activated(int) ), this, SLOT(slotItemChanged()));
	connect(expanderStyle, SIGNAL( activated(int) ), this, SLOT(slotItemChanged()));

	connect(customMenuColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customMenuTextColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customInactiveButtonColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customRadioOnColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customRadioOffColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customCheckOnColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customCheckOffColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customSliderColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customHoveredSliderColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customPressedSliderColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customSliderGrooveColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customActiveTabColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customInactiveTabColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(customPanelColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(expanderColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));
	connect(dotlineColor, SIGNAL( changed(const QColor &) ), this, SLOT(slotItemChanged()));

	connect(customMenuOpacity, SIGNAL( valueChanged(int) ), this, SLOT(slotItemChanged()));
	connect(saturation, SIGNAL( valueChanged(int) ), this, SLOT(slotItemChanged()));
	connect(stippleContrast, SIGNAL( valueChanged(int) ), this, SLOT(slotItemChanged()));
	connect(shadowDarkness, SIGNAL( valueChanged(int) ), this, SLOT(slotItemChanged()));
	connect(shadowOffset, SIGNAL( valueChanged(int) ), this, SLOT(slotItemChanged()));
	connect(dropShadowDarkness, SIGNAL( valueChanged(int) ), this, SLOT(slotItemChanged()));

	connect(menuTranslucency, SIGNAL(activated(int)), this, SLOT(slotMenuTranslucencyChanged(int )));
	connect(menuEffect, SIGNAL( activated(int) ), this, SLOT(slotItemChanged()));
	connect(menuEffectSpeed, SIGNAL( valueChanged(int) ), this, SLOT(slotMenuEffectSpeedChanged(int)));
	
	
	connect(inactiveButtonColor, SIGNAL(activated(int)), this, SLOT(slotInactiveButtonChanged(int )));
	connect( useCustomPanelColor, SIGNAL( toggled( bool ) ), customPanelColor, SLOT( setEnabled( bool ) ) );
	connect( useCustomMenuStyle, SIGNAL( toggled( bool ) ), buttonGroup6_2, SLOT( setEnabled( bool ) ) );
	connect( useCustomWidgetColor, SIGNAL( toggled( bool ) ), buttonGroup7, SLOT( setEnabled( bool ) ) );
	connect( drawDotlines, SIGNAL( toggled( bool ) ), buttonGroup9, SLOT( setEnabled( bool ) ) );
	connect( useCustomExpanderColor, SIGNAL( toggled( bool ) ), expanderColor, SLOT( setEnabled( bool ) ) );
	load();
	};


kcmbaghira::~kcmbaghira() {}


void kcmbaghira::load() {
	QSettings settings;

	// menu stuff
	menuTranslucency->setCurrentItem( settings.readNumEntry( "/qt/Baghira/menuTranslucency", 1));
	if (menuTranslucency->currentItem() >= 2){
		slotMenuTranslucencyChanged(menuTranslucency->currentItem());
		customMenuOpacity->setValue( settings.readNumEntry( "/qt/Baghira/customMenuOpacity", 50));
	}
	else
		customMenuOpacity->setValue(50);

	menuEffect->setCurrentItem( settings.readNumEntry( "/qt/Baghira/menuAnimation", 1));
	menuEffectSpeed->setValue(settings.readNumEntry( "/qt/Baghira/menuAnimationSpeed", 20));
	stippleMenu->setChecked( settings.readBoolEntry( "/qt/Baghira/stippleMenu", true));
	menuColorButton->setChecked( settings.readBoolEntry( "/qt/Baghira/menuColorButton", false));
	shadowedText->setChecked( settings.readBoolEntry( "/qt/Baghira/shadowedText", true));

	// color stuff
	icyButtons->setChecked( settings.readBoolEntry( "/qt/Baghira/icyButtons", true));
	saturation->setValue( settings.readNumEntry( "/qt/Baghira/saturation", 2));

	// widgets
	useCustomWidgetColor->setChecked( settings.readBoolEntry( "/qt/Baghira/useCustomWidgetColor", false));
	if (useCustomWidgetColor->isOn()){
		customRadioOnColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customRadioOnColor", ( int ) colorGroup().button().rgb())));
		customRadioOffColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customRadioOffColor", ( int ) colorGroup().background().rgb())));
		customCheckOnColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customCheckOnColor", ( int ) colorGroup().button().rgb())));
		customCheckOffColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customCheckOffColor", ( int ) colorGroup().background().rgb())));
		customSliderColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customSliderColor", ( int ) colorGroup().button().rgb())));
		customHoveredSliderColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customHoveredSliderColor",  ( int ) colorGroup().button().rgb())));
		customPressedSliderColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customPressedSliderColor", ( int ) colorGroup().button().dark(110).rgb())));
		customSliderGrooveColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customSliderGrooveColor", ( int ) colorGroup().background().rgb())));
		customActiveTabColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customActiveTabColor", ( int ) colorGroup().button().rgb())));
		customInactiveTabColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customInactiveTabColor", ( int ) colorGroup().background().rgb())));
	}
	else{
		customRadioOnColor->setColor(colorGroup().button());
		customRadioOffColor->setColor(colorGroup().background());
		customCheckOnColor->setColor(colorGroup().button());
		customCheckOffColor->setColor(colorGroup().background());;
		customSliderColor->setColor(colorGroup().background());;
		customHoveredSliderColor->setColor(colorGroup().button());
		customPressedSliderColor->setColor(colorGroup().button().dark(110));
		customSliderGrooveColor->setColor(colorGroup().background());;
		customActiveTabColor->setColor(colorGroup().button());
		customInactiveTabColor->setColor(colorGroup().background());;
		customPanelColor->setColor(colorGroup().background());;
	}
	// menu
	useCustomMenuStyle->setChecked( settings.readBoolEntry( "/qt/Baghira/useCustomMenuStyle", false));
	if (useCustomMenuStyle->isOn()){
		customMenuColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customMenuColor", (int) colorGroup().button().rgb())));
		customMenuTextColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customMenuTextColor", (int) colorGroup().text().rgb())));
	}
	else{
		customMenuColor->setColor(colorGroup().background());
		customMenuTextColor->setColor(colorGroup().background());
	}
	
	shadowOffset->setValue(settings.readNumEntry( "/qt/Baghira/shadowOffset", 8));
	dropShadowDarkness->setValue(settings.readNumEntry( "/qt/Baghira/dropShadowDarkness", 2));
	// Panel
	useCustomPanelColor->setChecked( settings.readBoolEntry( "/qt/Baghira/useCustomPanelColor", false));
	if (useCustomPanelColor->isOn())
		customPanelColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customPanelColor", (int) colorGroup().button().rgb())));
	else
		customPanelColor->setColor(colorGroup().button());
	// inactive Button
	inactiveButtonColor->setCurrentItem(settings.readNumEntry( "/qt/Baghira/inactiveButtonColor", 1));
	if (inactiveButtonColor->currentItem() == 3){
		slotInactiveButtonChanged(3);
		customInactiveButtonColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/customInactiveButtonColor", (int) colorGroup().background().rgb())));
	}
	else
		customInactiveButtonColor->setColor(colorGroup().background());

	//design stuff
	//stipple
	stippleBackground->setChecked( settings.readBoolEntry( "/qt/Baghira/stippleBackground", true));
	stipplePanel->setChecked( settings.readBoolEntry( "/qt/Baghira/stipplePanel", true));
	stippleContrast->setValue( settings.readNumEntry( "/qt/Baghira/stippleContrast", 30));
	//shadows
	useGroupShadows->setChecked( settings.readBoolEntry( "/qt/Baghira/useGroupShadows", true));
	shadowDarkness->setValue( settings.readNumEntry( "/qt/Baghira/shadowDarkness", 50));
	//ListViews
	expanderStyle->setCurrentItem(settings.readNumEntry( "/qt/Baghira/expanderStyle", 0));
	useCustomExpanderColor->setChecked( settings.readBoolEntry( "/qt/Baghira/useCustomExpanderColor", false));
	if (useCustomExpanderColor->isChecked())
		expanderColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/expanderColor", (int) colorGroup().text().rgb())));
	else
		expanderColor->setColor(colorGroup().text());
	drawDotlines->setChecked( settings.readBoolEntry( "/qt/Baghira/drawDotlines", true));
	if (drawDotlines->isChecked()){
		dotlineStyle->setCurrentItem(settings.readNumEntry( "/qt/Baghira/dotlineStyle", 0));
		dotlineColor->setColor( QColor( settings.readNumEntry( "/qt/Baghira/dotlineColor", (int) colorGroup().mid().rgb())));
	}
	else{
		dotlineStyle->setCurrentItem(0);
		dotlineColor->setColor(colorGroup().mid());
	}

	//slider
	squeeze->setChecked( settings.readBoolEntry( "/qt/Baghira/squeezeSbSlider", true));
	shadowSlider->setChecked( settings.readBoolEntry( "/qt/Baghira/shadowSbSlider", true));
	// toolbar
	drawToolbarButtonFrames->setChecked( settings.readBoolEntry( "/qt/Baghira/drawToolbarButtonFrames", true));
	smoothListViewHeaders->setChecked( settings.readBoolEntry( "/qt/Baghira/smoothListViewHeaders", false));

	// tweaks
	alignStipples->setChecked( settings.readBoolEntry( "/qt/Baghira/alignStipples", false));
	centerTabs->setChecked( settings.readBoolEntry( "/qt/Baghira/centerTabs", false));
	engageFB->setChecked( settings.readBoolEntry( "/qt/Baghira/engageFB", false));
	forceRectButtons->setChecked( settings.readBoolEntry( "/qt/Baghira/forceRectButtons", false));
	progressBar->setCurrentItem( settings.readNumEntry( "/qt/Baghira/progressBar", 0));
	removeKickerBevel->setChecked( settings.readBoolEntry( "/qt/Baghira/removeKickerBevel", false));
	smoothToolbuttons->setChecked( settings.readBoolEntry( "/qt/Baghira/smoothToolbuttons", false));
	smootherLVH->setChecked( settings.readBoolEntry( "/qt/Baghira/smootherLVH", false));
	drawProgressLabel->setChecked( settings.readBoolEntry( "/qt/Baghira/drawProgressLabel", false));
	menuDropShadows->setChecked( settings.readBoolEntry( "/qt/Baghira/menuDropShadows", true));


//	slotUseCustomColorClicked( useCustomColorBtn->isChecked() );
//	slotWidgetColorChanged( colorGroup().background() );
	emit changed( false );
	}


void kcmbaghira::defaults() {
	load();

	useCustomMenuStyle->setChecked(false);
	customMenuOpacity->setValue(50);
	menuColorButton->setChecked(false);
	shadowedText->setChecked(true);
	stippleMenu->setChecked(true);
	menuTranslucency->setCurrentItem(1);
	menuEffect->setCurrentItem(1);
	menuEffectSpeed->setValue(20);
	useCustomWidgetColor->setChecked(false);
	useCustomPanelColor->setChecked(true);
	customMenuColor->setColor(colorGroup().background());
	customMenuTextColor->setColor(colorGroup().background());
	customInactiveButtonColor->setColor(colorGroup().background());
	inactiveButtonColor->setCurrentItem(1);
	customRadioOnColor->setColor(colorGroup().button());
	customRadioOffColor->setColor(colorGroup().background());
	customCheckOnColor->setColor(colorGroup().button());
	customCheckOffColor->setColor(colorGroup().background());;
	customSliderColor->setColor(colorGroup().background());;
	customHoveredSliderColor->setColor(colorGroup().button());
	customPressedSliderColor->setColor(colorGroup().button().dark(110));
	customSliderGrooveColor->setColor(colorGroup().background());;
	customActiveTabColor->setColor(colorGroup().button());
	customInactiveTabColor->setColor(colorGroup().background());;
	customPanelColor->setColor(colorGroup().background());;
	stippleBackground->setChecked(true);
	stipplePanel->setChecked(true);
	drawToolbarButtonFrames->setChecked(true);
	squeeze->setChecked(true);
	stippleContrast->setValue(50);
	shadowDarkness->setValue(50);
	useCustomExpanderColor->setChecked(false);
	expanderColor->setColor(colorGroup().text());
	dotlineStyle->setCurrentItem(0);
	dotlineColor->setColor(colorGroup().mid());
	drawDotlines->setChecked(true);
	expanderStyle->setCurrentItem(0);
	shadowSlider->setChecked(true);
	smoothListViewHeaders->setChecked(false);
	useGroupShadows->setChecked(true);
	alignStipples->setChecked(false);
	centerTabs->setChecked(false);
	engageFB->setChecked(false);
	icyButtons->setChecked(true);
	saturation->setValue(2);
	forceRectButtons->setChecked(false);
	progressBar->setCurrentItem(0);
	removeKickerBevel->setChecked(false);
	smoothToolbuttons->setChecked(false);
	smootherLVH->setChecked(false);
	drawProgressLabel->setChecked(false);
	menuDropShadows->setChecked(true);
	shadowOffset->setValue(8);
	dropShadowDarkness->setValue(2);


	emit changed( true );
	}


void kcmbaghira::save() {
	QSettings * settings = new QSettings;

	bool doNext;
	// menu stuff
	settings->writeEntry("/qt/Baghira/menuTranslucency", menuTranslucency->currentItem());
	settings->writeEntry("/qt/Baghira/menuAnimation", menuEffect->currentItem());
	settings->writeEntry("/qt/Baghira/menuAnimationSpeed", menuEffectSpeed->value());
//	settings->writeEntry("/qt/Baghira/useCustomMenuStyle", doNext = useCustomMenuStyle->isOn()); // custom ?
	if (menuTranslucency->currentItem() >= 2)
		settings->writeEntry("/qt/Baghira/customMenuOpacity", customMenuOpacity->value());

	settings->writeEntry("/qt/Baghira/stippleMenu", stippleMenu->isOn());
	settings->writeEntry("/qt/Baghira/menuColorButton", menuColorButton->isOn());
	settings->writeEntry("/qt/Baghira/shadowedText", shadowedText->isOn());

	// color stuff
	settings->writeEntry("/qt/Baghira/icyButtons", icyButtons->isOn());
	settings->writeEntry("/qt/Baghira/saturation", saturation->value());

	// widgets
	settings->writeEntry("/qt/Baghira/useCustomWidgetColor", doNext = useCustomWidgetColor->isOn());
	if (doNext){
		settings->writeEntry("/qt/Baghira/customRadioOnColor", (int) customRadioOnColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customRadioOffColor", (int) customRadioOffColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customCheckOnColor", (int) customCheckOnColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customCheckOffColor", (int) customCheckOffColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customSliderColor", (int) customSliderColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customHoveredSliderColor", (int) customHoveredSliderColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customPressedSliderColor", (int) customPressedSliderColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customSliderGrooveColor", (int) customSliderGrooveColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customActiveTabColor", (int) customActiveTabColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customInactiveTabColor", (int) customInactiveTabColor->color().rgb());
	}
	// menu
	settings->writeEntry("/qt/Baghira/useCustomMenuStyle", doNext = useCustomMenuStyle->isOn());
	if (doNext){
		settings->writeEntry("/qt/Baghira/customMenuColor", (int) customMenuColor->color().rgb());
		settings->writeEntry("/qt/Baghira/customMenuTextColor", (int) customMenuTextColor->color().rgb());
	}
	settings->writeEntry("/qt/Baghira/shadowOffset", shadowOffset->value());
	settings->writeEntry("/qt/Baghira/dropShadowDarkness", dropShadowDarkness->value());
	// Panel
	settings->writeEntry("/qt/Baghira/useCustomPanelColor", doNext = useCustomPanelColor->isOn());
	if (doNext)
		settings->writeEntry("/qt/Baghira/customPanelColor", (int) customPanelColor->color().rgb());
	// inactive Button
	settings->writeEntry("/qt/Baghira/inactiveButtonColor", inactiveButtonColor->currentItem());
	if (inactiveButtonColor->currentItem() == 3)
		settings->writeEntry("/qt/Baghira/customInactiveButtonColor", (int) customInactiveButtonColor->color().rgb());

	//design stuff
	//stipple
	settings->writeEntry("/qt/Baghira/stippleBackground", stippleBackground->isOn());
	settings->writeEntry("/qt/Baghira/stipplePanel", stipplePanel->isOn());
	settings->writeEntry("/qt/Baghira/stippleContrast", stippleContrast->value());
	//shadows
	settings->writeEntry("/qt/Baghira/useGroupShadows", useGroupShadows->isOn());
	settings->writeEntry("/qt/Baghira/shadowDarkness", shadowDarkness->value());
	//ListViews
	settings->writeEntry("/qt/Baghira/expanderStyle", expanderStyle->currentItem());
	settings->writeEntry("/qt/Baghira/useCustomExpanderColor", doNext = useCustomExpanderColor->isOn());
	if (doNext)
		settings->writeEntry("/qt/Baghira/expanderColor", (int) expanderColor->color().rgb());
	settings->writeEntry("/qt/Baghira/drawDotlines", doNext = drawDotlines->isOn());
	if (doNext){
		settings->writeEntry("/qt/Baghira/dotlineStyle", dotlineStyle->currentItem());
		settings->writeEntry("/qt/Baghira/dotlineColor", (int)dotlineColor->color().rgb());
	}
	//slider
	settings->writeEntry("/qt/Baghira/squeezeSbSlider", squeeze->isOn());
	settings->writeEntry("/qt/Baghira/shadowSbSlider", shadowSlider->isOn());
	// toolbar
	settings->writeEntry("/qt/Baghira/drawToolbarButtonFrames", drawToolbarButtonFrames->isOn());
	settings->writeEntry("/qt/Baghira/smoothListViewHeaders", smoothListViewHeaders->isOn());

	// tweaks
	settings->writeEntry("/qt/Baghira/alignStipples", alignStipples->isOn());
	settings->writeEntry("/qt/Baghira/centerTabs", centerTabs->isOn());
	settings->writeEntry("/qt/Baghira/engageFB", engageFB->isOn());
	settings->writeEntry("/qt/Baghira/forceRectButtons", forceRectButtons->isOn());
	settings->writeEntry("/qt/Baghira/progressBar", progressBar->currentItem());
	settings->writeEntry("/qt/Baghira/removeKickerBevel", removeKickerBevel->isOn());
	settings->writeEntry("/qt/Baghira/smoothToolbuttons", smoothToolbuttons->isOn());
	settings->writeEntry("/qt/Baghira/smootherLVH", smootherLVH->isOn());
	settings->writeEntry("/qt/Baghira/drawProgressLabel", drawProgressLabel->isOn());
	settings->writeEntry("/qt/Baghira/menuDropShadows", menuDropShadows->isOn());


	delete settings; // force sync
	KIPC::sendMessageAll( KIPC::StyleChanged, 0 );
	emit changed( false );
	emit changed( true );
	}


int kcmbaghira::buttons() {
	return KCModule::Default | KCModule::Apply;
	}


void kcmbaghira::configChanged() {
	// insert your saving code here...
	emit changed( true );
	}


QString kcmbaghira::quickHelp() const {
	return i18n( "Configure your Big Black Cat." );
	}

/*
 *  Sets the strings of the subwidgets using the current
 *  language.
 */
void kcmbaghira::languageChange() {
	setCaption( tr( "Baghira Settings" ) );
	groupBox2->setTitle( tr( "Menu" ) );
	buttonGroup6_2->setTitle( QString::null );
	textLabel3_2->setText( tr( "Text" ) );
	textLabel2_2->setText( tr( "Menu" ) );
	customMenuColor->setText( QString::null );
	customMenuTextColor->setText( QString::null );
	useCustomMenuStyle->setText( tr( "Use custom menu style" ) );
	groupBox6_2->setTitle( tr( "Inactive Button" ) );
	buttonGroup8->setTitle( QString::null );
	textLabel2_4->setText( tr( "Custom" ) );
	customInactiveButtonColor->setText( QString::null );
	inactiveButtonColor->clear();
	inactiveButtonColor->insertItem( tr( "Original (unadjusted)" ) );
	inactiveButtonColor->insertItem( tr( "Background" ) );
	inactiveButtonColor->insertItem( tr( "Active Button" ) );
	inactiveButtonColor->insertItem( tr( "Custom" ) );
	inactiveButtonColor->setCurrentItem( 0 );
	groupBox4->setTitle( tr( "Widgets" ) );
	buttonGroup7->setTitle( QString::null );
	checkBox9->setText( QString::null );
	checkBox8->setText( QString::null );
	radioButton2->setText( QString::null );
	radioButton1->setText( QString::null );
	textLabel13->setText( tr( "Slider" ) );
	textLabel14->setText( tr( "Slider (hovered)" ) );
	textLabel15->setText( tr( "Slider (pressed)" ) );
	textLabel16->setText( tr( "Slider Groove" ) );
	textLabel18->setText( tr( "Tab (active)" ) );
	textLabel17->setText( tr( "Tab (inactive)" ) );
	customRadioOnColor->setText( QString::null );
	customRadioOffColor->setText( QString::null );
	customCheckOnColor->setText( QString::null );
	customCheckOffColor->setText( QString::null );
	customSliderColor->setText( QString::null );
	customHoveredSliderColor->setText( QString::null );
	customPressedSliderColor->setText( QString::null );
	customSliderGrooveColor->setText( QString::null );
	customActiveTabColor->setText( QString::null );
	customInactiveTabColor->setText( QString::null );
	useCustomWidgetColor->setText( tr( "Use custom Widget colors" ) );
	groupBox3->setTitle( tr( "Panel" ) );
	useCustomPanelColor->setText( tr( "Use custom Panel Color" ) );
	customPanelColor->setText( QString::null );
	styletab->changeTab( tab_2, tr( "Colors" ) );
	groupBox1->setTitle( tr( "Custom Settings" ) );
	textLabel8->setText( tr( "Opacity" ) );
	textLabel10->setText( tr( "Solid" ) );
	textLabel9->setText( tr( "Translucent" ) );
	stippleMenu->setText( tr( "Stipple the Menu" ) );
	menuColorButton->setText( tr( "Use Button, not Background Color for Menus" ) );
	shadowedText->setText( tr( "Shadowed Text" ) );
	menuTranslucency->clear();
	menuTranslucency->insertItem( tr( "Solid" ) );
	menuTranslucency->insertItem( tr( "Default" ) );
	menuTranslucency->insertItem( tr( "Custom" ) );
	menuTranslucency->insertItem( tr( "Gradient" ) );
	menuTranslucency->setCurrentItem( 1 );
	menuEffect->clear();
	menuEffect->insertItem( tr( "None" ) );
	menuEffect->insertItem( tr( "FadeIn" ) );
	menuEffect->insertItem( tr( "LeftScroll" ) );
	menuEffect->insertItem( tr( "RightScroll" ) );
	menuEffect->insertItem( tr( "UpScroll" ) );
	menuEffect->insertItem( tr( "DownScroll" ) );
	menuEffect->setCurrentItem( 1 );
	textLabel7->setText( tr( "Translucency" ) );
	menuEffectLabel->setText( tr( "Effect" ) );
	menuEffectSpeedLabel->setText( tr( "Speed" ) );
	menuEffectSpeedIndicator->setNum(menuEffectSpeed->value());
	saturationLabel->setText(tr("Saturation"));
	styletab->changeTab( tab_3, tr( "Menu Effects" ) );
	stippleBackground->setText( tr( "Stipple the Background" ) );
	stipplePanel->setText( tr( "Stipple the Panel" ) );
	textLabel6->setText( tr( "Contrast:" ) );
	textLabel2->setText( tr( "Low" ) );
	textLabel3->setText( tr( "High" ) );
	textLabel5->setText( tr( "Dark" ) );
	textLabel4->setText( tr( "Light" ) );
	drawToolbarButtonFrames->setText( tr( "Draw Toolbar Button Frames" ) );
	squeeze->setText( tr( "Squeeze pressed Scrollbar Sliders" ) );
	groupBox7->setTitle( tr( "ListViews" ) );
	textLabel4_3->setText( tr( "Expander Icon Style" ) );
	useCustomExpanderColor->setText( tr( "Use Custom Expander Icon Color" ) );
	expanderColor->setText( QString::null );
	buttonGroup9->setTitle( QString::null );
	dotlineStyle->clear();
	dotlineStyle->insertItem( tr( "Lines" ) );
	dotlineStyle->insertItem( tr( "Dotlines" ) );
	dotlineColor->setText( QString::null );
	drawDotlines->setText( tr( "Draw tree lines" ) );
	expanderStyle->clear();
	expanderStyle->insertItem( tr( "Apple (|>)" ) );
	expanderStyle->insertItem( tr( "MS (+/-)" ) );
	shadowSlider->setText( tr( "shadow Slider" ) );
	smoothListViewHeaders->setText( tr( "Draw smooth LVH" ) );
	useGroupShadows->setText( tr( "GroupShadows\n"
	                              "(only on new started)" ) );
	styletab->changeTab( tab_4, tr( "Design Effects" ) );
	textLabel4_2->setText( tr( "<h3>Warning: The Effects here are TWEAKS</h3>" ) );
	textLabel3_3->setText( tr( "<p align=\"center\">This means, they may work - <b>or not!</b><br><br></p>\n"
	                           "Allthough this should not happen, they could lead your Applications to <b>crash</b>.<br>\n"
	                           "<b>Be careful</b>, don't forget you changed things here and read the readme file!<br><br>\n"
	                           "Good luck." ) );
	alignStipples->setText( tr( "Force stipple alignment (slow)" ) );
	centerTabs->setText( tr( "Force Tabs to be centered" ) );
	engageFB->setText( tr( "Fasten the FileBrowser" ) );
	icyButtons->setText( tr( "Use icy Buttons (slower)" ) );
	forceRectButtons->setText( tr( "Force Rect Buttons" ) );
	progressBar->clear();
	progressBar->insertItem( tr( "Baghira" ) );
	progressBar->insertItem( tr( "Liquid" ) );
	progressBar->insertItem( tr( "Apple" ) );
	progressBar->setCurrentItem( 0 );
	removeKickerBevel->setText( tr( "Remove Kicker Bevel" ) );
	smoothToolbuttons->setText( tr( "Use smooth Toolbuttons" ) );
	smootherLVH->setText( tr( "Use smoother Task Buttons" ) );
	drawProgressLabel->setText( tr( "Draw useless Progress Value" ) );
	menuDropShadows->setText( tr( "Baghira Menudropshadows" "\n" "(please deactivate kde dropshadows in kcontrol/style" ) );
	shadowOffLabel->setText( tr( "Shadow Size" ) );
	dsdLabel->setText( tr( "Shadow Darkness" ) );

	styletab->changeTab( tab_5, tr( "Tweaks" ) );
	maintab->changeTab( tab, tr( "Style" ) );
	textLabel12->setText( trUtf8( "Copyleft 2003 by Thomas Lübking\n"
	                              "\n"
	                              "Baghira Bases Upon Mosfet's \"High Performance Liquid\"\n"
	                              "\n"
	                              "Since Mosfet has (at least temporary) left Liquid Development, I went on and called the new Branch \"Baghira\"\n"
	                              "\n"
	                              "\"Baghira\" is the German spelling of \"Bagheera\", the indish Word for Panther.\n"
	                              "\n"
	                              "The Design follows Apples latest OS (Codename \"Panther\")\n"
	                              "\n"
	                              "Special Thanks to Apple (for the Design), 'mosfet' (for writing the underlying code), 'CraigD' (for a lot of comments and suggestions) and 'shm' for centered tabs\n""Even more special Thanks to 'massive' for constantly providing rpms and strengthen my ego with positive comments!" ) );
	maintab->changeTab( tab_6, tr( "About" ) );
	}
/*
void kcmbaghira::adjustHSV( QImage &img, QImage &dest, const QColor &c, const QColor &bgColor ) {
	if ( img.depth() != 32 )
		img = img.convertDepth( 32 );
	dest.reset();
	dest.create( img.width(), img.height(), 32 );
	dest.setAlphaBuffer( true );
	unsigned int *data = ( unsigned int * ) img.bits();
	unsigned int *destData = ( unsigned int* ) dest.bits();
	int total = img.width() * img.height();
	int current;
	int delta;
	int destR, destG, destB, alpha;
	int srcR = c.red() + 20;
	int srcG = c.green() + 20;
	int srcB = c.blue() + 20;
	float srcPercent, destPercent;
	for ( current = 0; current < total; ++current ) {
		alpha = qAlpha( data[ current ] );
		delta = 255 - qRed( data[ current ] );
		destR = srcR - delta;
		destG = srcG - delta;
		destB = srcB - delta;
		if ( destR < 0 )
			destR = 0;
		if ( destG < 0 )
			destG = 0;
		if ( destB < 0 )
			destB = 0;
		if ( destR > 255 )
			destR = 255;
		if ( destG > 255 )
			destG = 255;
		if ( destB > 255 )
			destB = 255;

		if ( alpha != 255 && alpha != 0 ) {
			srcPercent = ( ( float ) alpha ) / 255.0;
			destPercent = 1.0 - srcPercent;
			destR = ( int ) ( ( srcPercent * destR ) + ( destPercent * bgColor.red() ) );
			destG = ( int ) ( ( srcPercent * destG ) + ( destPercent * bgColor.green() ) );
			destB = ( int ) ( ( srcPercent * destB ) + ( destPercent * bgColor.blue() ) );
			alpha = 255;
			}
		destData[ current ] = qRgba( destR, destG, destB, alpha );
		}
	}

void kcmbaghira::slotWidgetColorChanged( const QColor & ) {
	QPixmap pix;
	QImage img, dest;

	img = uic_findImage( "radio_down.png" );
	adjustHSV( img, dest, radioOnColorBtn->color(), colorGroup().background() );
	pix.convertFromImage( dest );
	radioOnLbl->setPixmap( pix );
	img = uic_findImage( "radio.png" );
	adjustHSV( img, dest, radioOffColorBtn->color(), colorGroup().background() );
	pix.convertFromImage( dest );
	radioOffLbl->setPixmap( pix );

	img = uic_findImage( "checkboxdown.png" );
	adjustHSV( img, dest, cbOnColorBtn->color(), colorGroup().background() );
	pix.convertFromImage( dest );
	cbOnLbl->setPixmap( pix );
	img = uic_findImage( "checkbox.png" );
	adjustHSV( img, dest, cbOffColorBtn->color(), colorGroup().background() );
	pix.convertFromImage( dest );
	cbOffLbl->setPixmap( pix );

	img = uic_findImage( "tab.png" );
	adjustHSV( img, dest, tabOnColorBtn->color(), colorGroup().background() );
	pix.convertFromImage( dest );
	tabOnLbl->setPixmap( pix );
	adjustHSV( img, dest, tabOffColorBtn->color(), colorGroup().background() );
	pix.convertFromImage( dest );
	tabOffLbl->setPixmap( pix );

	img = uic_findImage( "sbslider.png" );
	adjustHSV( img, dest, sbSliderColorBtn->color(), colorGroup().background() );
	pix.convertFromImage( dest );
	sbSliderLbl->setPixmap( pix );

	img = uic_findImage( "sbgroove.png" );
	adjustHSV( img, dest, sbGrooveColorBtn->color(), colorGroup().background() );
	pix.convertFromImage( dest );
	sbGrooveLbl->setPixmap( pix );

	emit changed( true );
	}
*/
extern "C" {

	KCModule *create_kcmbaghira( QWidget * parent, const char * name ) {
		KGlobal::locale() ->insertCatalogue( "kcmbaghira" );
		return new kcmbaghira( parent, "kcmbaghira" );
		}
	}

#include "kcmbaghira.moc"
