#ifndef _KCMBAGHIRA_H_
#define _KCMBAGHIRA_H_

#include <qvariant.h>
#include <qdialog.h>

#include <kcmodule.h>
#include <kaboutdata.h>

class QVBoxLayout;
class QHBoxLayout;
class QGridLayout;
class QTabWidget;
class QWidget;
class QGroupBox;
class QButtonGroup;
class QLabel;
class KColorButton;
class QCheckBox;
class QComboBox;
class QRadioButton;
class QSlider;
class QFrame;
class QSpinBox;

class kcmbaghira: public KCModule {
		Q_OBJECT

	public:
		kcmbaghira( QWidget *parent = 0, const char *name = 0 );
		~kcmbaghira();

		virtual void load();
		virtual void save();
		virtual void defaults();
		virtual int buttons();
		virtual QString quickHelp() const;
		virtual const KAboutData *aboutData() {
			return myAboutData;
			};

	public slots:
		void configChanged();

	protected slots:
		void slotInactiveButtonChanged(int id);
		void slotMenuTranslucencyChanged(int id);
		void slotItemChanged();
		void slotMenuEffectSpeedChanged(int id);
/*		void slotBtnGroupClicked( int id );

		void slotColorOptionChanged();
		void slotUsePanelCustomClicked( bool on );
		void slotUseCustomColorClicked( bool on );
		void slotPanelColorChanged( const QColor &c );
		void slotWidgetColorChanged( const QColor &c );
		void slotSliderChanged( int val );
*/
	protected:
	/*	void adjustHSV( QImage &img, QImage &dest, const QColor &c,
		                const QColor &bgColor );
*/

		void languageChange();
		QCheckBox* useCustomMenuStyle;
		QSlider* customMenuOpacity;
		QSlider* menuEffectSpeed;
		QCheckBox* menuColorButton;
		QCheckBox* stippleMenu;
		QCheckBox* shadowedText;
		QComboBox* menuTranslucency;
		QComboBox* menuEffect;
		QCheckBox* useCustomWidgetColor;
		QCheckBox* useCustomPanelColor;
		KColorButton* customMenuColor;
		KColorButton* customMenuTextColor;
		KColorButton* customInactiveButtonColor;
		QComboBox* inactiveButtonColor;
		KColorButton* customRadioOnColor;
		KColorButton* customRadioOffColor;
		KColorButton* customCheckOnColor;
		KColorButton* customCheckOffColor;
		KColorButton* customSliderColor;
		KColorButton* customHoveredSliderColor;
		KColorButton* customPressedSliderColor;
		KColorButton* customSliderGrooveColor;
		KColorButton* customActiveTabColor;
		KColorButton* customInactiveTabColor;
		KColorButton* customPanelColor;
		QCheckBox* stippleBackground;
		QCheckBox* stipplePanel;
		QCheckBox* drawToolbarButtonFrames;
		QCheckBox* squeeze;
		QSlider* stippleContrast;
		QSlider* shadowDarkness;
		QCheckBox* useCustomExpanderColor;
		KColorButton* expanderColor;
		QComboBox* dotlineStyle;
		KColorButton* dotlineColor;
		QCheckBox* drawDotlines;
		QComboBox* expanderStyle;
		QCheckBox* shadowSlider;
		QCheckBox* smoothListViewHeaders;
		QCheckBox* useGroupShadows;
		QCheckBox* alignStipples;
		QCheckBox* centerTabs;
		QCheckBox* engageFB;
		QCheckBox* icyButtons;
		QSlider* saturation;
		QLabel *saturationLabel;
		QCheckBox* forceRectButtons;
		QComboBox* progressBar;
		QCheckBox* drawProgressLabel;
		QCheckBox* removeKickerBevel;
		QCheckBox* smoothToolbuttons;
		QCheckBox* smootherLVH;
		QCheckBox* menuDropShadows;
		QSpinBox* shadowOffset;
		QLabel* shadowOffLabel;
		QSlider* dropShadowDarkness;
		QLabel* dsdLabel;


		QTabWidget* maintab;
		QWidget* tab;
		QTabWidget* styletab;
		QWidget* tab_2;
		QGroupBox* groupBox2;
		QButtonGroup* buttonGroup6_2;
		QLabel* textLabel3_2;
		QLabel* textLabel2_2;
		QGroupBox* groupBox6_2;
		QButtonGroup* buttonGroup8;
		QLabel* textLabel2_4;
		QGroupBox* groupBox4;
		QButtonGroup* buttonGroup7;
		QCheckBox* checkBox9;
		QCheckBox* checkBox8;
		QRadioButton* radioButton2;
		QRadioButton* radioButton1;
		QLabel* textLabel13;
		QLabel* textLabel14;
		QLabel* textLabel15;
		QLabel* textLabel16;
		QLabel* textLabel18;
		QLabel* textLabel17;
		QLabel* menuEffectLabel;
		QLabel* menuEffectSpeedLabel;
		QLabel* menuEffectSpeedIndicator;
		QGroupBox* groupBox3;
		QWidget* tab_3;
		QGroupBox* groupBox1;
		QLabel* textLabel8;
		QLabel* textLabel10;
		QLabel* textLabel9;
		QLabel* textLabel7;
		QWidget* tab_4;
		QFrame* line1;
		QFrame* line1_2;
		QLabel* textLabel6;
		QLabel* textLabel2;
		QLabel* textLabel3;
		QLabel* textLabel5;
		QLabel* textLabel4;
		QGroupBox* groupBox7;
		QLabel* textLabel4_3;
		QButtonGroup* buttonGroup9;
		QWidget* tab_5;
		QLabel* textLabel4_2;
		QLabel* textLabel3_3;
		QFrame* line7;
		QWidget* tab_6;
		QLabel* textLabel12;

	private:
		KAboutData *myAboutData;
	};

#endif
