#include "baghira.h"
//#include <qguardedptr.h>
#include <kwordwrap.h> 
//#include <kdebug.h>

#define CLAMP(x,l,u) x < l ? l :\
		     x > u ? u :\
		     x

#define ALPHA_COLOR(A,R,G,B) \
    destR = ((A * destR) + (255 - A) * R) / 255; \
    destG = ((A * destG) + (255 - A) * G) / 255; \
    destB = ((A * destB) + (255 - A) * B) / 255; \
    A = 255;
    
#define DELTA_COLOR(D,R,G,B) \
    delta = 255 - qRed(D); \
    destR = srcR - delta; \
    destG = srcG - delta; \
    destB = srcB - delta;
    
#define SATURATION_COLOR(S,R,G,B) \
    grey = (299 * R + 587 * G + 114 * B) / 1000; \
    delta = 255 - grey; \
    grey = (grey *(10 - S)) / 10; \
    iGrey = 255 - grey;\
    destR = (iGrey * (srcR - delta) + grey * R) / 255; \
    destG = (iGrey * (srcG - delta) + grey * G) / 255; \
    destB = (iGrey * (srcB - delta) + grey * B) / 255; 
    
#define GM_COLOR(R,G,B)\
    destR = CLAMP(destR + R - 128, 0, 255);\
    destG = CLAMP(destG + G - 128, 0, 255);\
    destB = CLAMP(destB + B - 128, 0, 255);

    
#define COLOR_SPACE(R,G,B) \
    if ( R < 0 ) R = 0; else if ( R > 255 ) R = 255; \
    if ( G < 0 ) G = 0; else if ( G > 255 ) G = 255; \
    if ( B < 0 ) B = 0; else if ( B > 255 ) B = 255;
    

    
int LiquidStyle::getBrightness(unsigned int rgb) const {
	int red = qRed( rgb );
	int green = qGreen( rgb );
	int blue = qBlue( rgb );
	int V = red;
	if (green > V)  V = green;
	if (blue > V)  V = blue;
	return V;
}

QPixmap* LiquidStyle::adjustHSV( QImage &img, const QColor &c,
                                 bool blend, const QColor *bg ) const 
{
    QImage * tmp = adjustHSVImage( img, c, blend, bg );
//    QImage *tmp = apple( &img, &c, blend, bg);
//    int h, s, v;
//    c.getHsv( &h, &s, &v );
//    QColor c2;
//    c2.setHsv(h-15,s,v);
//    QImage *tmp = grain_merge(&img, &c2);
    QPixmap *pix = new QPixmap;
    pix->convertFromImage( *tmp );
//    delete tmp2;
    delete tmp;
    return ( pix );
}

QImage* LiquidStyle::adjustHSVImage( QImage &img, const QColor &c,
                                     bool blend, const QColor *bg ) const
{
    QColor bgColor( bg ? *bg : qApp->palette().active().background() );

    if ( img.depth() != 32 )
    	img = img.convertDepth( 32 );
    QImage *dest = new QImage( img.width(), img.height(), 32 );
    dest->setAlphaBuffer( true );
    unsigned int *data = ( unsigned int * ) img.bits();
    unsigned int *destData = ( unsigned int* ) dest->bits();
    int total = img.width() * img.height();
    int current;
    int delta, uplight;
    int red, green, blue, grey, iGrey;
    int destR, destG, destB, alpha;
  
    int srcR = c.red();
    int srcG = c.green();
    int srcB = c.blue();

    if (!optionHandler->IcyButtons()){
    	uplight = 20;
    	srcR += uplight;
    	srcG += uplight;
    	srcB += uplight;
    }
    
    COLOR_SPACE(srcR, srcG, srcB);

    // float srcPercent, destPercent;
    for ( current = 0 ; current < total ; ++current ) {
    	alpha = qAlpha( data[ current ] );
	if (optionHandler->IcyButtons()) {
    	    red = qRed( data[ current ] );
    	    green = qGreen( data[ current ] );
	    blue = qBlue( data[ current ] );
	    SATURATION_COLOR(optionHandler->Saturation(), red, green, blue);
// 	    int h, s, v;
// 	    c.getHsv( &h, &s, &v );
// 	    if (s > 50){
// 	    QColor c2;
// 	    c2.setHsv(h-15,s,v);
// 	    int srcR2 = c2.red();
//             int srcG2 = c2.green();
// 	    int srcB2 = c2.blue();
// 	    GM_COLOR(srcR2, srcG2, srcB2);
//	    }
	}
	else {
	    // the coloring itself
	    DELTA_COLOR(data[ current ], srcR, srcG, srcB);
	}
	if ( blend && alpha && alpha != 255 ) {
	   // only on translucent pixels - alphablending
	   ALPHA_COLOR(alpha, bgColor.red(), bgColor.green(), bgColor.blue());
	}
	// force back to valid colorspace !
	COLOR_SPACE(destR, destG, destB);
	destData[ current ] = qRgba( destR, destG, destB, alpha );
    }
    return ( dest );
}

// ok, what apple does: first: burn with the chosen color, then: reduce hue value (not too much =), last grain merge with the new color


QImage *LiquidStyle::apple (QImage *image, const QColor *color, bool blend, const QColor *bg ) const{

	QColor bgColor( bg ? *bg : qApp->palette().active().background() );
	
	if ( image->depth() != 32 )
		*image = image->convertDepth( 32 );
	
	const uint *src2 = (uint *) image->bits();
	
	int colorR = color->red();
	int colorG = color->green();
	int colorB = color->blue();
	
	QImage *appled = new QImage(image->width(), image->height(), 32);
	appled->setAlphaBuffer( true );
	uint *dest = (uint *) appled->bits();
	
	uint length = image->width()*image->height();


	int destR, destG, destB, alpha;
	int red, green, blue;

	for (int current = 0; current < length; ++current){
	 	red = qRed( src2[ current ] );
		green = qGreen( src2[ current ] );
		blue = qBlue( src2[ current ] );
		alpha = qAlpha( src2[ current ] );
		
		// color handling
/*		destR = (255 - colorR) << 8;
		destR /= red + 1;
		destR = (uint) CLAMP(255 - destR, 0, 255);
		destG = (255 - colorG) << 8;
		destG /= green + 1;
		destG = (uint) CLAMP(255 - destG, 0, 255);
		destB = (255 - colorB) << 8;
		destB /= blue + 1;
		destB = (uint) CLAMP(255 - destB, 0, 255);
		if ( blend && alpha && alpha != 255 ) {
	  	 	// only on translucent pixels - alphablending
	   		ALPHA_COLOR(alpha, bgColor.red(), bgColor.green(), bgColor.blue());
		}
		COLOR_SPACE(destR, destG, destB);*/

		//grain merge
		destR = CLAMP(red + colorR - 128, 0, 255);
		destG = CLAMP(green + colorG - 128, 0, 255);
		destB = CLAMP(blue + colorB - 128, 0, 255);
		// alpha handling
		dest[ current ] = qRgba( destR, destG, destB, alpha );
	}
	return appled;
}



void LiquidStyle::clearImage( QImage &img ) const
{
    int x, y;
    int w = img.width();
    int h = img.height();
    unsigned int pixel = qRgba( 0, 0, 0, 0 );
    unsigned int *data;

    for ( y = 0 ; y < h ; ++y ) 
    	for ( data = (unsigned int *) img.scanLine( y ), x = 0 ; x < w ; data[ x++ ] = pixel ) ;
    // img.fill( pixel );
}

void LiquidStyle::adjustHSV( QPixmap &pix, const QColor &c ) const
{
    QImage img = pix.convertToImage();
    QPixmap *result = adjustHSV( img, c, false );
    pix = *result;
    delete result;
}


/* buttons are fractioned to 9 parts.
w, h are width and height of the whole button.
xOff  (yOff) is the distance of the central fraction from left (upper) button side.
centerW (centerH) is the width (height) of the central button fraction.
shadowH is the height of the buttons shadow*/
ButtonTile* LiquidStyle::createButtonTile( const QColor &c, 
					   const QColor &bgColor, 
                                           QImage *buttonImage, 
					   QImage *shadowImage, 
					   QImage *glowImage, 
					   QIntDict<ButtonTile>*buttonDict, 
					   QIntDict<ButtonTile>*shadowDict, 
					   QIntDict<ButtonTile>*glowDict, 
					   int w, int h, int xOff, int yOff, 
					   int centerW, int centerH, 
					   int shadowH, int glowWH, 
					   bool sunken, bool hover ) const
{
    int x, y, delta, uplight;
    int red, green, blue, grey, iGrey;
    int destR, destG, destB, alpha;
    float srcPercent, destPercent;
    unsigned int bgPixel = bgColor.rgb();

    optionHandler->IcyButtons() ? uplight = 0 : uplight = 20;
    int srcR = (c.red() + uplight);
    int srcG = (c.green() + uplight);
    int srcB = (c.blue() + uplight);

    COLOR_SPACE(srcR, srcG, srcB);
    
    unsigned int *data, *destData;
    LiquidStyle *ptr = const_cast<LiquidStyle*>( this );
    ButtonTile *tile;

    int shadowOverhead;
    shadowH > glowWH ? shadowOverhead = shadowH - glowWH : shadowOverhead = 0;
    QImage img( w + 2*glowWH + shadowOverhead, h + 2*glowWH + shadowOverhead, 32 );
    img.setAlphaBuffer( !isPlain() || optionHandler->drawGroupBoxShadow() ? true : false);
    clearImage( img );

    // For unpressed buttons things are a little more complex. First
    // we color adjust the shadow with the background color then we
    // adjust the button to the button color. Finally we overlay the
    // button on the shadow, (in the same loop as color adjusting).
    // Technically we probably could of gotten away
    // with just adjusting both the shadow and the button to the button
    // color since the shadow is quite dark, but this is more correct and
    // would allow configurable shadow brightness. If the shadow was
    // just the button color, if someone configured it to be a rather
    // light brightness, and they had a dark background color it wouldn't
    // look right if based off the button color.
    //
    // Luckily this is only done once when the button is created for any
    // given color ;-)

    // first do the shadow
    if (!sunken && (shadowImage/* != NULL*/))
	for ( y = 0 ; y < h + shadowH ; ++y ) {
    	    data = ( unsigned int * ) shadowImage->scanLine( y );
	    destData = ( unsigned int * ) img.scanLine( y + glowWH ); // glowWH is the yOffset -> distance of visable button to top of complete button
    	    for ( x = 0 ; x < w ; ++x )
    		if (alpha = qAlpha( data[ x ] )) {
		    DELTA_COLOR(data[ x ], srcR, srcG, srcB);
		    if (alpha != 255) {
			ALPHA_COLOR(alpha, bgColor.red(), bgColor.green(), bgColor.blue());
		    }
		    COLOR_SPACE(destR, destG, destB);
		    destData[ x + glowWH ] = qRgba( destR, destG, destB, alpha );
		}
	}
    // ... or the glow
    else if (glowImage/* != NULL */)
	for ( y = 0 ; y < h + 2*glowWH ; ++y ) {
	    data = ( unsigned int * ) glowImage->scanLine( y );
	    destData = ( unsigned int * ) img.scanLine( y );
	    for ( x = 0 ; x < w + 2*glowWH ; ++x )
    		if (alpha = qAlpha( data[ x ] )) {
		    DELTA_COLOR(data[ x ], srcR, srcG, srcB);
		    if (alpha != 255) {
			ALPHA_COLOR(alpha, bgColor.red(), bgColor.green(), bgColor.blue());
		    }
		    COLOR_SPACE(destR, destG, destB);
		    destData[ x ] = qRgba( destR, destG, destB, alpha );
		}
	}
    
    // then the button and overlay
    for ( y = 0 ; y < h ; ++y ) {
	data = ( unsigned int * ) buttonImage->scanLine( y );
	destData = ( unsigned int * ) img.scanLine( y + glowWH );
	for ( x = 0 ; x < w ; ++x )
	    if (alpha = qAlpha( data[ x ] )) {
		if (optionHandler->IcyButtons()) {
	    	    red = qRed( data[ x ] );
	    	    green = qGreen( data[ x ] );
	    	    blue = qBlue( data[ x ] );
	    	    SATURATION_COLOR(optionHandler->Saturation(), red, green, blue);
		}
		else {
		    DELTA_COLOR(data[ x ], srcR, srcG, srcB);
		}
		if (alpha != 255) {
	    	    if ( qAlpha( destData[ x + glowWH ] ) ) {
	    		ALPHA_COLOR(alpha, qRed( destData[ x + glowWH ]), qGreen( destData[ x + glowWH ]), qBlue( destData[ x + glowWH ]));
		    }
		    else {
			ALPHA_COLOR(alpha, bgColor.red(), bgColor.green(), bgColor.blue());
		    }
		    alpha = 255;
		}
		COLOR_SPACE(destR, destG, destB);
		destData[ x + glowWH ] = qRgba( destR, destG, destB, alpha );
	    }
    }

    // Are we plain? If so fill in transparent pixels (must be after overlay)
    if ( isPlain() && !optionHandler->drawGroupBoxShadow() ) {
	delta = h + glowWH + ((shadowH > glowWH) ? shadowH : glowWH);
	grey = w + 2 * glowWH;
	for ( y = 0 ; y < delta ; ++y )
	    for (destData = (unsigned int *) img.scanLine( y ), x = 0 ; x < grey ; ++x )
		if ( qAlpha( destData[ x ] ) == 0 ) destData[ x ] = bgPixel;
    }
    QPixmap *pix = new QPixmap;
    pix->convertFromImage( img );
    tile = separateTiles( pix, xOff, yOff, centerW, centerH, shadowH, sunken, optionHandler->drawGroupBoxShadow() );
    if ( sunken && glowDict /*!= NULL*/)
    	glowDict->insert(c.rgb(),tile);
    else if (!sunken && shadowDict /*!= NULL*/)
	shadowDict->insert( c.rgb(), tile );
    else
	buttonDict->insert( c.rgb(), tile );
    delete pix;
    return ( tile );
}

QPixmap* LiquidStyle::createSliderEnd( const QColor &c, const QColor &bgColor, bool top/*, bool vertical */) const
{
    int x, y, delta, uplight;
    int red, green, blue, grey, iGrey;
    int destR, destG, destB, alpha;
    float srcPercent, destPercent;
    unsigned int bgPixel = bgColor.rgb();
    optionHandler->IcyButtons() ? uplight = 0 : uplight = 20;    
    int srcR = (c.red() + uplight);
    int srcG = (c.green() + uplight);
    int srcB = (c.blue() + uplight);

    COLOR_SPACE(srcR, srcG, srcB);

    unsigned int *data, *destData;
    LiquidStyle *ptr = const_cast<LiquidStyle*>( this );
    ButtonTile *tile;

    QImage img( 13, 9, 32 );
    img.setAlphaBuffer( true ); // we need this always, as the slider groove is nevernever plain!
    clearImage( img );

    // just stole that from above...
    // first do the shadow
    for ( y = 0 ; y < 9 ; ++y ) {
	top ? data = ( unsigned int * ) slider_top_shd->scanLine( y ) : data = ( unsigned int * ) slider_btm_shd->scanLine( y );
	destData = ( unsigned int * ) img.scanLine( y );
	for ( x = 0; x < 13; ++x )
	    if (alpha = qAlpha( data[ x ] )) {
		DELTA_COLOR(data[ x ], srcR, srcG, srcB);
		if (alpha != 255 ) {
		    ALPHA_COLOR(alpha, bgColor.red(), bgColor.green(), bgColor.blue());
		}
		COLOR_SPACE(destR, destG, destB);
		destData[ x ] = qRgba( destR, destG, destB, alpha );
	    }
    }
    // then the button and overlay
    for ( y = 0 ; y < 7 ; ++y ) {
	top ? data = ( unsigned int * ) slider_top->scanLine( y ) : data = ( unsigned int * ) slider_btm->scanLine( y );
	destData = ( unsigned int * ) img.scanLine( top ? y + 2 : y );
	for ( x = 0 ; x < 13 ; ++x )
	    if (alpha = qAlpha( data[ x ] )) {
		if (optionHandler->IcyButtons()) {
	    	    red = qRed( data[ x ] );
	    	    green = qGreen( data[ x] );
	    	    blue = qBlue( data[ x] );
		    SATURATION_COLOR(optionHandler->Saturation(), red, green, blue);
		}
		else {
	    	    DELTA_COLOR(data[ x ], srcR, srcG, srcB);
		}
		if (alpha != 255) {
		    if ( qAlpha( destData[ x ] ) ) {
			ALPHA_COLOR(alpha, qRed( destData[ x ]), qGreen( destData[ x ]), qBlue( destData[ x ]));
		    }
		    else {
			ALPHA_COLOR(alpha, bgColor.red(), bgColor.green(), bgColor.blue());
		    }
		}
		COLOR_SPACE(destR, destG, destB);
		destData[ x ] = qRgba( destR, destG, destB, alpha );
	    }
    }
    QPixmap *pix = new QPixmap;
    pix->convertFromImage( img );
    return ( pix );
}



//   0     /  xO  /  xO + w
// -------------------------------------
// | xO   | w   | width()-xO-w | : yO 			/   0
// -------------------------------------
// | xO   | w   | width()-xO-w | : h 				/   yO
// -------------------------------------
// | xO   | w   | width()-xO-w | : height()-yO-h  	/  yO+h
// -------------------------------------
// Overload of mosfet's original function, takes 6 more parameters to use the funktion on variable bitmaps (mosfet's function does only work for very special bitmaps)
// by giving position and dimension of the central tile + the shadow height (panther doesn't seem to have a right shadow-offset)
ButtonTile* LiquidStyle::separateTiles( QPixmap *pix, 
					int xO, int yO, int w, int h, 
					int sh, bool sunken, bool forceAlpha ) const
{
    ButtonTile * tile = new ButtonTile();
    QPixmap *tmp;
    QBitmap *tmpMask;

    int w1 = xO;
    int w2 = w;
    int w3 = pix->width() - xO - w;
    int h1 = yO;
    int h2 = h;
    int h3 = pix->height() - yO - h;

    int xO1 = 0;
    int xO2 = xO;
    int xO3 = xO + w;
    int yO1 = 0;
    int yO2 = yO;
    int yO3 = yO + h;

    if ( !sunken ) {
	// Top tiles
	tmp = new QPixmap( w1, h1 );
	// bitBlt(...,x,y,width,height)
	bitBlt( tmp, 0, 0, pix, xO1, yO1, w1, h1 );
	tile->setPixmap( TileTopLeft, tmp );
	tmp = new QPixmap( w2, h1 );
	bitBlt( tmp, 0, 0, pix, xO2, yO1, w2, h1 );
	tile->setPixmap( TileTop, tmp );
	tmp = new QPixmap( w3, h1 );
	bitBlt( tmp, 0, 0, pix, xO3, yO1, w3, h1 );
	tile->setPixmap( TileTopRight, tmp );

	// Middle tiles
	tmp = new QPixmap( w1, h2 );
	bitBlt( tmp, 0, 0, pix, xO1, yO2, w1, h2 );
	tile->setPixmap( TileLeft, tmp );
	tmp = new QPixmap( w2, h2 );
	bitBlt( tmp, 0, 0, pix, xO2, yO2, w2, h2 );
	tile->setPixmap( TileMiddle, tmp );
	tmp = new QPixmap( w3, h2 );
	bitBlt( tmp, 0, 0, pix, xO3, yO2, w3, h2 );
	tile->setPixmap( TileRight, tmp );

	// Bottom tiles
	tmp = new QPixmap( w1, h3 );
	bitBlt( tmp, 0, 0, pix, xO1, yO3, w1, h3 );
	tile->setPixmap( TileBtmLeft, tmp );
	tmp = new QPixmap( w2, h3 );
	bitBlt( tmp, 0, 0, pix, xO2, yO3, w2, h3 );
	tile->setPixmap( TileBtm, tmp );
	tmp = new QPixmap( w3, h3 );
	bitBlt( tmp, 0, 0, pix, xO3, yO3, w3, h3 );
	tile->setPixmap( TileBtmRight, tmp );

	if ( !isPlain() || forceAlpha ) {
    	    tmpMask = new QBitmap( w1, h1 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO1, yO1, w1, h1 );
	    tile->pixmap( TileTopLeft ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w2, h1 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO2, yO1, w2, h1 );
	    tile->pixmap( TileTop ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w3, h1 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO3, yO1, w3, h1 );
	    tile->pixmap( TileTopRight ) ->setMask( *tmpMask );
	    delete tmpMask;

	    tmpMask = new QBitmap( w1, h2 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO1, yO2, w1, h2 );
	    tile->pixmap( TileLeft ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w2, h2 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO2, yO2, w2, h2 );
	    tile->pixmap( TileMiddle ) ->setMask( *tmpMask );
	    delete tmpMask;
	    
	    tmpMask = new QBitmap( w3, h2 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO3, yO2, w3, h2 );
	    tile->pixmap( TileRight ) ->setMask( *tmpMask );
	    delete tmpMask;

	    tmpMask = new QBitmap( w1, h3 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO1, yO3, w1, h3 );
	    tile->pixmap( TileBtmLeft ) ->setMask( *tmpMask );
	    delete tmpMask;
	    
	    tmpMask = new QBitmap( w2, h3 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO2, yO3, w2, h3 );
	    tile->pixmap( TileBtm ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w3, h3 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO3, yO3, w3, h3 );
	    tile->pixmap( TileBtmRight ) ->setMask( *tmpMask );
	    delete tmpMask;
	}
    } 
    else {
	// Top tiles
	tmp = new QPixmap( w1, h3 );
	// bitBlt(...,x,y,width,height)
	bitBlt( tmp, 0, 0, pix, xO1, yO1, w1, h3 );
	tile->setPixmap( TileTopLeft, tmp );
	tmp = new QPixmap( w2, h3 );
	bitBlt( tmp, 0, 0, pix, xO2, yO1, w2, h3 );
	tile->setPixmap( TileTop, tmp );
	tmp = new QPixmap( w3, h3 );
	bitBlt( tmp, 0, 0, pix, xO3, yO1, w3, h3 );
	tile->setPixmap( TileTopRight, tmp );

	// Middle tiles
	tmp = new QPixmap( w1, h2 );
	bitBlt( tmp, 0, 0, pix, xO1, yO2 + h3 - h1, w1, h2 );
	tile->setPixmap( TileLeft, tmp );
	tmp = new QPixmap( w2, h2 );
	bitBlt( tmp, 0, 0, pix, xO2, yO2 + h3 - h1, w2, h2 );
	tile->setPixmap( TileMiddle, tmp );
	tmp = new QPixmap( w3, h2 );
	bitBlt( tmp, 0, 0, pix, xO3, yO2 + h3 - h1, w3, h2 );
	tile->setPixmap( TileRight, tmp );

	// Bottom tiles
	tmp = new QPixmap( w1, h1 );
	bitBlt( tmp, 0, 0, pix, xO1, yO3 + h3 - h1, w1, h1 );
	tile->setPixmap( TileBtmLeft, tmp );
	tmp = new QPixmap( w2, h1 );
	bitBlt( tmp, 0, 0, pix, xO2, yO3 + h3 - h1, w2, h1 );
	tile->setPixmap( TileBtm, tmp );
	tmp = new QPixmap( w3, h1 );
	bitBlt( tmp, 0, 0, pix, xO3, yO3 + h3 - h1, w3, h1 );
	tile->setPixmap( TileBtmRight, tmp );

	if ( !isPlain() || forceAlpha ) {
	    tmpMask = new QBitmap( w1, h3 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO1, yO1, w1, h3 );
	    tile->pixmap( TileTopLeft ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w2, h3 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO2, yO1, w2, h3 );
	    tile->pixmap( TileTop ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w3, h3 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO3, yO1, w3, h3 );
	    tile->pixmap( TileTopRight ) ->setMask( *tmpMask );
	    delete tmpMask;
	    
	    tmpMask = new QBitmap( w1, h2 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO1, yO2 + h3 - h1, w1, h2 );
	    tile->pixmap( TileLeft ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w2, h2 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO2, yO2 + h3 - h1, w2, h2 );
	    tile->pixmap( TileMiddle ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w3, h2 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO3, yO2 + h3 - h1, w3, h2 );
	    tile->pixmap( TileRight ) ->setMask( *tmpMask );
	    delete tmpMask;

	    tmpMask = new QBitmap( w1, h1 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO1, yO3 + h3 - h1, w1, h1 );
	    tile->pixmap( TileBtmLeft ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w2, h1 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO2, yO3 + h3 - h1, w2, h1 );
	    tile->pixmap( TileBtm ) ->setMask( *tmpMask );
	    delete tmpMask;
	    tmpMask = new QBitmap( w3, h1 );
	    bitBlt( tmpMask, 0, 0, pix->mask(), xO3, yO3 + h3 - h1, w3, h1 );
	    tile->pixmap( TileBtmRight ) ->setMask( *tmpMask );
	    delete tmpMask;
	}
    }
    return ( tile );
}

void LiquidStyle::drawClearBevel( QPainter *p, 
				  int x, int y, int w, int h, 
				  const QColor &c, const QColor &bg ) const
{
    LiquidStyle * ptr = const_cast<LiquidStyle*>( this );
    QPen oldPen = p->pen(); // headers need this
    int x2 = x + w - 1;
    int y2 = y + h - 1;

    // outer dark rect
    p->setPen( c.dark( 115 ) );
    p->drawLine( x + 2, y, x2 - 2, y ); // t
    p->drawLine( x, y + 2, x, y2 - 2 ); // l
    p->drawPoint( x + 1, y + 1 ); // tl
    p->setPen( c.dark( 150 ) );
    p->drawLine( x + 2, y2, x2 - 2, y2 ); // b
    p->drawLine( x2, y + 2, x2, y2 - 2 ); // r
    p->drawPoint( x2 - 1, y2 - 1 ); // br
    p->setPen( c.dark( 132 ) );
    p->drawPoint( x2 - 1, y + 1 ); // tr
    p->drawPoint( x + 1, y2 - 1 ); // bl

    // inner top light lines
    p->setPen( c.light( 105 ) );
    p->drawLine( x + 2, y + 1, x2 - 2, y + 1 );
    p->drawLine( x + 1, y + 2, x2 - 1, y + 2 );
    p->drawLine( x + 1, y + 3, x + 2, y + 3 );
    p->drawLine( x2 - 2, y + 3, x2 - 1, y + 3 );
    p->drawPoint( x + 1, y + 4 );
    p->drawPoint( x2 - 1, y + 4 );

    // inner bottom light lines
    p->setPen( c.light( 110 ) );
    p->drawLine( x + 2, y2 - 1, x2 - 2, y2 - 1 );
    p->drawLine( x + 1, y2 - 2, x2 - 1, y2 - 2 );
    p->drawLine( x + 1, y2 - 3, x + 2, y2 - 3 );
    p->drawLine( x2 - 2, y2 - 3, x2 - 1, y2 - 3 );
    p->drawPoint( x + 1, y2 - 4 );
    p->drawPoint( x2 - 1, y2 - 4 );

    // inner left mid lines
    //p->setPen(c.light(105));
    p->setPen( c );
    p->drawLine( x + 1, y + 5, x + 1, y2 - 5 );
    p->drawLine( x + 2, y + 4, x + 2, y2 - 4 );

    // inner right mid lines
    p->drawLine( x2 - 1, y + 5, x2 - 1, y2 - 5 );
    p->drawLine( x2 - 2, y + 4, x2 - 2, y2 - 4 );
    
    // fill
    QPixmap *pix;
    if ( h >= 32 ) {
    	pix = bevelFillDict.find( c.rgb() );
	if ( !pix ) {
	    pix = new QPixmap( *bevelFillPix );
	    adjustHSV( *pix, c );
	    ptr->bevelFillDict.insert( c.rgb(), pix );
	}
    }
    else {
	pix = smallBevelFillDict.find( c.rgb() );
	if ( !pix ) {
	    pix = new QPixmap( *smallBevelFillPix );
	    adjustHSV( *pix, c );
	    ptr->smallBevelFillDict.insert( c.rgb(), pix );
	}
    }
    p->drawTiledPixmap( x + 3, y + 3, w - 6, h - 6, *pix );
    // blend
    int red, green, blue;
    QColor btnColor( c.dark( 130 ) );
    red = ( btnColor.red() >> 1 ) + ( bg.red() >> 1 );
    green = ( btnColor.green() >> 1 ) + ( bg.green() >> 1 );
    blue = ( btnColor.blue() >> 1 ) + ( bg.blue() >> 1 );
    btnColor.setRgb( red, green, blue );

    p->setPen( btnColor );
    p->drawPoint( x + 1, y );
    p->drawPoint( x, y + 1 );
    p->drawPoint( x + 1, y2 );
    p->drawPoint( x, y2 - 1 );

    p->drawPoint( x2 - 1, y );
    p->drawPoint( x2, y + 1 );
    p->drawPoint( x2 - 1, y2 );
    p->drawPoint( x2, y2 - 1 );

    p->setPen( oldPen );
}

void LiquidStyle::drawRoundButton( QPainter *painter, 
				   const QColorGroup &cg, 
				   const QColor &c, 
				   const QColor &back, 
				   int x, int y, int w, int h, 
				   bool supportPushDown, 
				   bool pushedDown, bool hover, 
				   bool autoDefault, bool isHTML, 
				   int bgX, int bgY ) const
{
    if ( isHTML ) {
	drawRectangularButton( painter, c, x, y, w, h, pushedDown );
	return ;
    }
    if ( ( w < 21 || h < 25 )/* && !autoDefault*/ ) {
	//	drawClearBevel( painter, x, y, w, h, c, back );
        drawCombo( painter, cg, c, x, y, w, h+2, pushedDown, hover, false, center );
	QPen oldpen(painter->pen());
        painter->setPen( c.dark(150));
	painter->drawRect(x,y,w,h);
        if (pushedDown) {
    	    painter->setPen(c.dark(180));
	    painter->drawRect(x+1,y+1,w-2,h-2);
	}
	painter->setPen(oldpen);
	return ;
    }
    LiquidStyle *ptr = const_cast<LiquidStyle*>( this );
    ButtonTile *tile = pushedDown ? btnDict.find( c.rgb() ) : btnShadowedDict.find( c.rgb() );

    if ( !tile )
	tile = createButtonTile( c, cg.background(), ptr->btnBorderImg, ptr->btnShadowImg, ptr->buttonGlow, &(ptr->btnDict), &(ptr->btnShadowedDict), &(ptr->buttonGlowDict), 37, 21, 12, 11, 17, 1, 2, 2, pushedDown, hover );

    if ( !tile ) {
	qWarning( "Button tile is NULL!" );
	return ;
    }
    if ( !tmpBtnPix )
	ptr->tmpBtnPix = new QPixmap( w, h );
    else if ( w > tmpBtnPix->width() || h > tmpBtnPix->height() ) {
	// make temp pixmap size == largest button
	delete tmpBtnPix;
	ptr->tmpBtnPix = new QPixmap( w, h );
    }

    QPainter p;
    p.begin( tmpBtnPix );

    if ((optionHandler->GroupShadowButton()) && (this->groupShadow != NULL))
	p.drawTiledPixmap( 0, 0, w, h, *(this->groupShadow), bgX, bgY );
    else {
	QPixmap *stipple = cg.brush( QColorGroup::Background ).pixmap();
	if ( !stipple )   // button may have custom colorgroup
	    stipple = qApp->palette().active().brush( QColorGroup::Background ).pixmap();
	
	if ( !isPlain() && bgX != -1 && bgY != -1 && stipple ) 
	    p.drawTiledPixmap( 0, 0, w, h, *stipple, bgX, bgY );
	else
	    p.fillRect( 0, 0, w, h, back );
    }

    if ( !pushedDown ) {
	// corners
	// tiled fills
	if ( w > 22 ) {
    	    p.drawTiledPixmap( 12, 0, w - 24, 11, *tile->pixmap( TileTop ) );
	    p.drawTiledPixmap( 12, h - 13, w - 24, 13, *tile->pixmap( TileBtm ) );
	}
	if ( h > 24 ) {
	    p.drawTiledPixmap( 0, 11, 12, h - 24, *tile->pixmap( TileLeft ) );
	    p.drawTiledPixmap( w - 12, 11, 12, h - 24, *tile->pixmap( TileRight ) );
	}
	if ( w > 22 && h > 24 )
	    p.drawTiledPixmap( 12, 11, w - 24, h - 24, *tile->pixmap( TileMiddle ) );
	    
	p.drawPixmap( 0, 0, *tile->pixmap( TileTopLeft ) );
	p.drawPixmap( w - 12, 0, *tile->pixmap( TileTopRight ) );
	p.drawPixmap( 0, h - 13, *tile->pixmap( TileBtmLeft ) );
	p.drawPixmap( w - 12, h - 13, *tile->pixmap( TileBtmRight ) );
    }
    else {
	if ( w > 22 ) {
	    p.drawTiledPixmap( 12, 0, w - 24, 13, *tile->pixmap( TileTop ) );
	    p.drawTiledPixmap( 12, h - 11, w - 24, 13-2, *tile->pixmap( TileBtm ) );
	}
	if ( h > 24 ) {
	    p.drawTiledPixmap( 0, 13, 12, h - 24, *tile->pixmap( TileLeft ) );
	    p.drawTiledPixmap( w - 12, 13, 12, h - 24, *tile->pixmap( TileRight ) );
	}
	if ( w > 22 && h > 24 )
	    p.drawTiledPixmap( 12, 13, w - 24, h - 24, *tile->pixmap( TileMiddle ) );
	    
	p.drawPixmap( 0, 0, *tile->pixmap( TileTopLeft ) );
	p.drawPixmap( w - 12, 0, *tile->pixmap( TileTopRight ) );
	p.drawTiledPixmap( 0, h - 11,12,13-2, *tile->pixmap( TileBtmLeft ) );
	p.drawTiledPixmap( w - 12, h - 11,12,13-2, *tile->pixmap( TileBtmRight ) );
    }
    p.end();
    painter->drawPixmap( x, y, *tmpBtnPix, 0, 0, w, h );
}


void LiquidStyle::drawRectangularButton( QPainter *painter, 
					 const QColor &c, 
					 int x, int y, int w, int h, 
					 bool sunken, bool hover, bool isCombo ) const
{
    LiquidStyle *ptr = const_cast<LiquidStyle*>( this );

    QColor tmpColor;
    (isCombo && !(hover || sunken))/* || (!isCombo && hover)*/ ? tmpColor = optionHandler->InactiveButtonColor() : tmpColor = c;
    //	if (!isCombo && hover) tmpColor= optionHandler->InactiveButtonColor();

    ButtonTile *tile = rectBtnDict.find( tmpColor.rgb() );
    if ( !tile )
    	tile = createButtonTile( tmpColor, tmpColor, ptr->rectbutton,((QImage*)NULL),((QImage*)NULL), &(ptr->rectBtnDict), (QIntDict<ButtonTile>*)NULL, (QIntDict<ButtonTile>*)NULL, 40, 22, 12, 1, 17, 20, 0, 0, sunken, false);

    if ( !tile ) {
	qWarning( "Button tile is NULL!" );
	return ;
    }
    if ( !tmpBtnPix )
	ptr->tmpBtnPix = new QPixmap( w, h );
    else if ( w > tmpBtnPix->width() || h > tmpBtnPix->height() ) {
	// make temp pixmap size == largest button
	delete tmpBtnPix;
	ptr->tmpBtnPix = new QPixmap( w, h );
    }
    QPainter p;
    p.begin( tmpBtnPix );

    int uh = (int)((h-20) / 2);
    int bh = h -20 - uh;

    // corners
    // tiled fills
    if ( w > 22 ) {
	p.drawPixmap( 0, uh, *tile->pixmap( TileLeft ) );
	if (!isCombo)
	    p.drawPixmap( w - 11, uh, *tile->pixmap( TileRight ) );
	    
	p.drawTiledPixmap( 12, uh, w - 23, 20, *tile->pixmap( TileMiddle ) ); //OK
	if ( h > 20 ) {
	    p.drawTiledPixmap( 0, 0,12,uh, *tile->pixmap( TileTopLeft ) );
	    if (!isCombo)
		p.drawTiledPixmap( w - 11, 0,11,uh, *tile->pixmap( TileTopRight ) );
		
	    p.drawTiledPixmap( 0, h - bh,12,bh, *tile->pixmap( TileBtmLeft ) );
	    if (!isCombo)
		p.drawTiledPixmap( w - 11, h - bh,11,bh, *tile->pixmap( TileBtmRight ) );
		
	    p.drawTiledPixmap( 12, 0, w-23, uh, *tile->pixmap( TileTop ) ); //OK
	    p.drawTiledPixmap( 12, h - bh, w - 23, bh, *tile->pixmap( TileBtm ) ); //OK
	}
    }
    else {
	int hMid = (int)(w/2);
	p.drawPixmap( hMid-12, uh, *tile->pixmap( TileLeft ) );
	if (!isCombo)
	    p.drawPixmap( hMid, uh, *tile->pixmap( TileRight ) );
	if ( h > 20 ) {
	    p.drawTiledPixmap( 0, 0,12,uh, *tile->pixmap( TileTopLeft ) );
	    if (!isCombo)
		p.drawTiledPixmap( w - 11, 0,11,uh, *tile->pixmap( TileTopRight ) );
		
	    p.drawTiledPixmap( 0, h - bh,12,bh, *tile->pixmap( TileBtmLeft ) );
	    if (!isCombo)
		p.drawTiledPixmap( w - 11, h - bh,11,bh, *tile->pixmap( TileBtmRight ) );
	}
    }

    if (isCombo) {
	tile = rectBtnDict.find( c.rgb() );
	if ( !tile )
	    tile = createButtonTile( c, c, ptr->rectbutton, ((QImage*)NULL), ((QImage*)NULL), &(ptr->rectBtnDict), (QIntDict<ButtonTile>*)NULL, (QIntDict<ButtonTile>*)NULL, 40, 22, 12, 1, 17, 20, 0, 0, sunken, false );
	
	if ( !tile ) {
	    qWarning( "Button tile is NULL!" );
	    return ;
	}
	if ( w > 22 ) {
	    p.drawPixmap( w - 11, uh, *tile->pixmap( TileRight ) );
	    if ( h > 20 ) {
		p.drawTiledPixmap( w - 11, 0,11,uh, *tile->pixmap( TileTopRight ) );
		p.drawTiledPixmap( w - 11, h - bh,11,bh, *tile->pixmap( TileBtmRight ) );
	    }
	}
	else {
	    int hMid = (int)(w/2);
	    p.drawPixmap( hMid, uh, *tile->pixmap( TileRight ) );
	    if ( h > 20 ) { 
		p.drawTiledPixmap( w - 11, 0,11,uh, *tile->pixmap( TileTopRight ) );
		p.drawTiledPixmap( w - 11, h - bh,11,bh, *tile->pixmap( TileBtmRight ) );
	    }
	}
	p.setPen(c.dark(120));
	p.drawLine(w-12,0,w-12,h);
	p.drawLine(w-13,0,w-13,h);
    }

    if (!sunken) {
	if (hover) {
	    p.setPen(c.dark(120));
	    p.drawRect(1,1,w-2,h-2);
	}
	else
	    p.setPen(c.dark(150));
	p.drawRect(0,0,w,h);
    }
    else {
	p.setPen(c.dark(150));
	p.drawLine(1,y,w-1,y);
	p.drawLine(1,h-1,w-1,h-1);
	p.drawLine(0,y,0,h-1);
	p.drawLine(w-1,y,w-1,h-1);
	p.setPen(c.dark(120));
	p.drawLine(1,y+1,w-2,y+1);
	p.drawLine(1,h-2,w-2,h-2);
	p.drawLine(1,y,1,h-1);
	p.drawLine(w-2,y,w-2,h-1);
	//	p.drawLine(0,h-1,w-1,h-1);
    }
    p.setPen(c.dark(110));
    p.drawPoint(0,0);p.drawPoint(w-1,0);p.drawPoint(0,h-1);p.drawPoint(w-1,h-1);

    if ( isCombo ) {
	SFlags flags = Style_Default;
	int ah = h / 3;
	int aw = 11;
	int ax = w - 9;
	int ay = ( h - ah ) / 2;
	//	x = x2 - 16;

	QPointArray a;
	p.setPen(optionHandler->textColor());
	p.setBrush( optionHandler->textColor() );
	a.setPoints( 3, ax, ay + 3, ax + 2, ay - 2, ax + 4, ay + 3 ); //UpArrow
	p.drawPolygon( a );
	a.setPoints( 3, ax, ay + 5, ax + 2, ay + 10, ax + 4, ay + 5 ); //DownArrow
	p.drawPolygon( a );
    }
    p.end();
    painter->drawPixmap( x, y, *tmpBtnPix, 0, 0, w, h );
}

void LiquidStyle::drawCombo( QPainter *painter, 
			    const QColorGroup &cg, 
			    const QColor &c, 
			    int x, int y, int w, int h, 
			    bool sunken, bool hover, bool isCombo, 
			    int position ) const
{
    LiquidStyle *ptr = const_cast<LiquidStyle*>( this );

    QColor tmpColor;
    tmpColor = isCombo && !(hover || sunken) ? optionHandler->InactiveButtonColor() : c;

    int xOffset, width;

    if (position == left) {
	xOffset = 7;
	width = w - 7;
    }
    else if (position == center) {
	xOffset = 0;
	width = w;
    }
    else if (position == right) {
	xOffset = 0;
	width = w - 7;
    }
    else if (position == full) {
	xOffset = 7;
	width = w - 14;
    }

    ButtonTile *tile = sunken ? comboDict.find( tmpColor.rgb() ) : comboShadowedDict.find( tmpColor.rgb() );
    if ( !tile )
	tile = createButtonTile( tmpColor, cg.background(), ptr->combo, ptr->comboShadow, ((QImage*)NULL), &(ptr->comboDict), &(ptr->comboShadowedDict), (QIntDict<ButtonTile>*)NULL, 44, 21, 7, 9, 30, 1, 2, 0, sunken, false);

    if ( !tile ) {
	qWarning( "Button tile is NULL!" );
	return ;
    }
    if ( !tmpBtnPix )
	ptr->tmpBtnPix = new QPixmap( w, h );
    else if ( w > tmpBtnPix->width() || h > tmpBtnPix->height() ) {
	// make temp pixmap size == largest button
	delete tmpBtnPix;
	ptr->tmpBtnPix = new QPixmap( w, h );
    }

    QPainter p;
    p.begin( tmpBtnPix );

    QPixmap *stipple = cg.brush( QColorGroup::Background ).pixmap();
    if ( !stipple )  // button may have custom colorgroup
	stipple = qApp->palette().active().brush( QColorGroup::Background ).pixmap();
    if ( !isPlain() && /*bgX != -1 && bgY != -1 &&*/ stipple )
	p.drawTiledPixmap( 0, 0, w, h, *stipple/*, bgX, bgY */);
    else
	p.fillRect( 0, 0, w, h, cg.background() );

    if ( !sunken ) { // unsunken or unhovered combos a splitted
	// corners
	// tiled fills
	if ( w > 14 ) {
	    p.drawTiledPixmap( xOffset, 0, width, 9, *tile->pixmap( TileTop ) );
	    p.drawTiledPixmap( xOffset, h - 13, width, 13, *tile->pixmap( TileBtm ) );
	}
	if ( h > 22 ) {
	    if (position == left || position == full)
		p.drawTiledPixmap( 0, 9, 7, h - 22, *tile->pixmap( TileLeft ) );
	    if ((!isCombo || hover) && (position == right || position == full))
		p.drawTiledPixmap( w - 7, 9, 7, h - 22, *tile->pixmap( TileRight ) );
	}
	if ( w > 14 && h > 22 )
	    p.drawTiledPixmap( xOffset, 9, width, h - 22, *tile->pixmap( TileMiddle ) );
	if (position == left || position == full)
	    p.drawPixmap( 0, 0, *tile->pixmap( TileTopLeft ) );
	if ((!isCombo || hover) && (position == right || position == full))
	    p.drawPixmap( w - 7, 0, *tile->pixmap( TileTopRight ) );
	if (position == left || position == full)
	    p.drawPixmap( 0, h - 13, *tile->pixmap( TileBtmLeft ) );
	if ((!isCombo || hover) && (position == right || position == full))
	    p.drawPixmap( w - 7, h - 13, *tile->pixmap( TileBtmRight ) );
    }
    else { // for sunken or hovered we have just one color - one button
	if ( w > 14 ) {
    	    p.drawTiledPixmap( xOffset, 0, width, 13, *tile->pixmap( TileTop ) );
	    p.drawTiledPixmap( xOffset, h - 9, width, 13-2, *tile->pixmap( TileBtm ) );
	}
	if ( h > 22 ) {
	    if (position == left || position == full)
		p.drawTiledPixmap( 0, 13, 7, h - 22, *tile->pixmap( TileLeft ) );
	    //if (!isCombo)
	    if (position == right || position == full)
		p.drawTiledPixmap( w - 7, 13, 7, h - 22, *tile->pixmap( TileRight ) );
	}
	if ( w > 14 && h > 22 )
    	    p.drawTiledPixmap( xOffset, 13, width, h - 22, *tile->pixmap( TileMiddle ) );
	if (position == left || position == full) {
	    p.drawPixmap( 0, 0, *tile->pixmap( TileTopLeft ) );
    	    p.drawTiledPixmap( 0, h - 9,7,13-2, *tile->pixmap( TileBtmLeft ) );
	}
	if (position == right || position == full) {
	    p.drawPixmap( w - 7, 0, *tile->pixmap( TileTopRight ) );
	    p.drawTiledPixmap( w - 7, h - 9,7,13-2, *tile->pixmap( TileBtmRight ) );
	}
	/*  p.setPen(c.dark(160));
	p.drawLine(8,y+3-2,w-8,y+3-2);
	p.drawLine(8,h-1-2,w-8,h-1-2);
	p.setPen(c.dark(130));
	p.drawLine(6,y+4-2,w-6,y+4-2); */
    }

    if (position == center){
	p.setPen(c.dark(150));
	p.drawLine(0,0,0,h);
	p.drawLine(w,0,w,h);
    }

    if (isCombo && !(hover || sunken)) { // second part of combos if needed
	tile = sunken ? comboDict.find( c.rgb() ) : comboShadowedDict.find( c.rgb() );
	if ( !tile )
	    tile = createButtonTile( c, cg.background(), ptr->combo, ptr->comboShadow, (QImage*)NULL, &(ptr->comboDict), &(ptr->comboShadowedDict), (QIntDict<ButtonTile>*)NULL, 44, 21, 7, 9, 30, 1, 2,0, sunken, hover );
	if ( !tile ) {
    	    qWarning( "Button tile is NULL!" );
	    return ;
	}
	// corners
	// tiled fills
	if ( w > 14 ) {
	    p.drawTiledPixmap( w-18, 0, 11, 9, *tile->pixmap( TileTop ) );
	    p.drawTiledPixmap( w-18, h - 13, 11, 13, *tile->pixmap( TileBtm ) );
	}
	if ( h > 22 )
	    p.drawTiledPixmap( w - 7, 9, 7, h - 22, *tile->pixmap( TileRight ) );
	if ( w > 14 && h > 22 )
	    p.drawTiledPixmap( w-18, 9, 11, h - 22, *tile->pixmap( TileMiddle ) );
	p.drawPixmap( w - 7, 0, *tile->pixmap( TileTopRight ) );
	p.drawPixmap( w - 7, h - 13, *tile->pixmap( TileBtmRight ) );
    }

    if (isCombo) {
	p.setPen(c.dark(130));
	p.drawLine(w-18,1,w-18,h-4);
	p.drawLine(w-17,1,w-17,h-4);

	SFlags flags = Style_Default;
	int ah = h / 3;
	int aw = 11;
	int ax = w - 12;
	int ay = ( h - ah ) / 2 -1;
	/*// Are we enabled?
	if ( widget->isEnabled() )
	    flags |= Style_Enabled;
	// Are we "pushed" ?
	if ( active & Style_Sunken )
	    flags |= Style_Sunken;
	*/

	QPointArray a;
	p.setPen(cg.text());
	p.setBrush( cg.text() );
/*	a.setPoints( 3, ax, ay + 3, ax + 2, ay - 2, ax + 4, ay + 3 ); //UpArrow
	p.drawPolygon( a );
	a.setPoints( 3, ax, ay + 5, ax + 2, ay + 10, ax + 4, ay + 5 ); //DownArrow
	p.drawPolygon( a );*/
	p.drawPixmap(ax, ay-1, *sbUp, 1, 0, 5, 4);
	p.drawPixmap(ax, ay+6, *sbDown, 1, 2, 5, 4);
    }

    p.end();
    painter->drawPixmap( x, y, *tmpBtnPix, 0, 0, w, h );
}



void LiquidStyle::drawEditFrame( QPainter *p, const QRect &r,
                                 const QColorGroup &cg, bool isHTML, bool focused ) const
{
    QColor fill( cg.background().dark( 105 ) );
    QColor light1( 0, 0, 0 );
    QColor light2( 0, 0, 0 );

    QColor dark1( 0, 0, 0 );
    QColor dark2( 0, 0, 0 );
    QColor dark3( 0, 0, 0 );

    if ( !focused ) {
	light1 = cg.background().dark( 115 );
	light2 = cg.background().dark( 120 );

	dark1 = cg.background().dark( 140 );
	dark2 = cg.background().dark( 160 );
	dark3 = cg.background().dark( 200 );
    } 
    else {
	light1 = cg.button();
	light2 = cg.button().dark( 105 );
	
	dark1 = cg.button().dark( 110 );
	dark2 = cg.button().dark( 115 );
	dark3 = cg.button().dark( 120 );
    }

    if ( !isHTML ) {
	p->setPen( fill );
	p->drawPoint( r.x(), r.y() );
	p->drawPoint( r.x(), r.bottom() );
	p->drawPoint( r.right(), r.y() );
	p->drawPoint( r.right(), r.bottom() );

	// outer rect
	// top
	p->setPen( light1 );
	p->drawPoint( r.x() + 1, r.y() );
	p->drawPoint( r.right() - 1, r.y() );
	p->drawPoint( r.x(), r.y() + 1 );
	p->drawPoint( r.right(), r.y() + 1 );
	// bottom
	p->drawPoint( r.x(), r.bottom() - 1 );
	p->drawPoint( r.right(), r.bottom() - 1 );
	p->drawPoint( r.x() + 1, r.bottom() );
	p->drawPoint( r.right() - 1, r.bottom() );
	// top
	p->setPen( dark3 );
	p->drawLine( r.x() + 2, r.y(), r.right() - 2, r.y() );
	// bottom, left and right
	if ( !focused )
	    p->setPen( cg.background() );
        p->drawLine( r.x() + 2, r.bottom(), r.right() - 2, r.bottom() );
        p->drawLine( r.x(), r.y() + 2, r.x(), r.bottom() - 2 );
        p->drawLine( r.right(), r.y() + 2, r.right(), r.bottom() - 2 );
    } 
    else {
        p->setPen( light2 );
        p->drawLine( r.x(), r.y(), r.right(), r.y() );
        p->drawLine( r.x(), r.y(), r.x(), r.bottom() );
        p->setPen( dark1 );
        p->drawLine( r.x(), r.bottom(), r.right(), r.bottom() );
        p->drawLine( r.right(), r.y(), r.right(), r.bottom() );
    }
    // inner rect
    p->setPen( dark1 );
    p->drawPoint( r.x() + 1, r.y() + 1 );
    p->drawPoint( r.x() + 1, r.bottom() - 1 );
    p->drawPoint( r.right() - 1, r.y() + 1 );
    p->drawPoint( r.right() - 1, r.bottom() - 1 );
    p->setPen( dark2 );
    p->drawLine( r.x() + 2, r.y() + 1, r.right() - 2, r.y() + 1 );
    p->setPen( dark2 );
    p->drawLine( r.x() + 2, r.bottom() - 1, r.right() - 2, r.bottom() - 1 );
    p->drawLine( r.x() + 1, r.y() + 2, r.x() + 1, r.bottom() - 2 );
    p->drawLine( r.right() - 1, r.y() + 2, r.right() - 1, r.bottom() - 2 );
}

bool LiquidStyle::isHTMLWidget( const QWidget *widget ) const
{
    const QObject * w = widget->parent();
    if ( w ) {
    	if ( !w->inherits( "QClipperWidget" ) )
    	    return ( false );
	w = w->parent();
	if ( w ) {
	    w = w->parent();
	    if ( w && w->inherits( "KHTMLView" ) )
		return ( true );
	}
    }
    return ( false );
}

void LiquidStyle::drawHTMLCBBorder( const QPixmap &pix, const QColor &c ) const
{
    QPainter p;
    p.begin( &pix );
    p.setPen( c.dark( 200 ) );
    p.drawRect( 0, 0, 16, 16 );
    p.end();
}
